/*
SEXOPOLIS FIGHT ARENA, a script for Sexscripts
by kinkyswan

Script:
    fight_arena.groovy                         MIT License

This script, from http://ss.deviatenow.com, is protected by an MIT license (license applies only to the script contained in this file, not the accompanying images and sounds):
 
------------------------------ BEGIN MIT LICENSE ------------------------------
Copyright 2017 kinkyswan

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
------------------------------- END MIT LICENSE -------------------------------

Images:
    fight_arena/chart_experience.png           https://creativecommons.org/publicdomain/zero/1.0/
    fight_arena/chart_practice.png             https://creativecommons.org/publicdomain/zero/1.0/
    fight_arena/chart_speed_and_doping.png     https://creativecommons.org/publicdomain/zero/1.0/
    fight_arena/default_coach.png              public domain; derived from https://openclipart.org/detail/220757/red-haired-woman
    fight_arena/default_fighter_levelXX.png    public domain; derived from https://openclipart.org/detail/244037/superhero
    fight_arena/fight_ring.png                 https://creativecommons.org/publicdomain/zero/1.0/
    fight_arena/title_screen.png               https://creativecommons.org/publicdomain/zero/1.0/
    
Sounds:
    fight_arena/bodyslam1shoulder.mp3
    fight_arena/bodyslam2yelp_high.mp3
    fight_arena/bodyslam3moan_high.mp3
    fight_arena/end_fight_ding.mp3
    fight_arena/fight_results.mp3
    fight_arena/flick1.mp3
    fight_arena/flick3.mp3
    fight_arena/introduce_fighters.mp3
    fight_arena/kick1kick.mp3
    fight_arena/kick2cry_high.mp3
    fight_arena/kick3groan_high.mp3
    fight_arena/point_scored.mp3
    fight_arena/punch1punch.mp3
    fight_arena/punch2grunt_high.mp3
    fight_arena/punch3_high.mp3
    fight_arena/sound_test.mp3
    fight_arena/spank1.mp3
    fight_arena/spank5.mp3
    fight_arena/start_fight_ding.mp3
    fight_arena/target_pressed_no_point.mp3
    fight_arena/won_tournament.mp3    

Sounds were created using Melody Assistant (http://www.myriad-online.com/en/products/melody.htm) and Audacity (http://www.audacityteam.org/)
It's not clear what licensing is allowed for MP3 exports from these applications, but so far as my creative input into these files is concerned, you can do what you like with these sound files.

This script was inspired by Fight_Script_Redux by Shaggy. I rather enjoy that script, and have found myself coming back to it fairly often. As much as I like it, though, it has a few shortcomings that have always bothered me: (1) it makes no sense that a fighter who is bound both hand and foot can still bind an opponent, (2) there's no actual punishment for losing a fight, and (3) although there are three different opponents, they are actually different in picture only, with no difference in how they fight or how difficult they are to beat.

I set about creating a new script--with the same basic idea of fighting opponents in an arena--to address those problems, and Sexopolis Fight Arena is what I wound up with. I hope you will find it enjoyable. By the way, I found Manual.txt (http://ss.deviatenow.com/download/file.php?id=267) to be an invaluable resource.

ORGANIZATION OF THE SCRIPT
  1. Constants          
  2. Global variables
  3. Closures
  4. Main script  
*/
    
    
setInfos(6, "Sexopolis Fight Arena", "Hone your fighting skills in real-time 4-minute bouts as one of 1024 contestants in single-elimination tournaments, each held over 10 days of chastity. Beware: each time you lose a fight you have to perform favors for the fighter who beat you!", "kinkyswan", "Version 1.00", 0xDDFFDD, "en", ["formale", "forfemale", "femaledom", "maledom", "chastity", "cbt", "nipple torture", "spanking", "punishment", "long"]);


// ######################################################## CONSTANTS ########################################################

def BACKGROUND_COLOR = "#ddffdd" // Screen background color (should match color argument in setInfos)
def FOLDER_NAME = "fight_arena/"  // Name of subfolder under sounds and images
def MESSAGE_MODE = "all"        // "none" or "all" (use "none" for testing)
def PAUSE_AMOUNT = 2            // Number of seconds messages are displayed
def NUM_FIGHT_LEVELS = 10       // Number of fight levels in the tournament 
int NUM_COMPETITORS = Math.pow(2, NUM_FIGHT_LEVELS)  // Number of competitors in the tournament
def POINTS_TO_WIN = 3           // The first fighter to earn this many points within a fight wins that fight
def MIN_SPEED = 1               // Lowest possible speed that each fighter can have
def MAX_SPEED = 10              // Highest possible speed that each fighter can have
def PLAYER_SPEED = 5            // The human player's speed
def MIN_STRENGTH = 1            // Lowest possible strength that each fighter can have
def MAX_STRENGTH = 10           // Highest possible strength that each fighter can have
def PLAYER_STRENGTH = 5         // The human player's strength
def MIN_HEALTH = 0              // Lowest possible health that each fighter can have
def MAX_HEALTH = 10             // Highest possible health that each fighter can have
def BASE_PRIORITY = 200         // Each fighter starts a fight with at least this priority level
def REST_THRESHOLD = 8          // At this value or less for the fighter's health, a computer fighter will choose the rest option for an attack
def ATTACK_OPTIONS_BASE = 5     // The minimal number of times each attack option (other than rest) will be added to the attack options spread (see attack closure below)
                                //   and also used in the computation of attack and defense scores (see attack closure below)
def TARGET_ACT_CHANCE = 2       // The chance that a pressed target button will be activated is 1 over TARGET_ACT_CHANCE (e.g. 1 in 2 for TARGET_ACT_CHANCE of 2)
def STAY_PUT = true             // Used with showStatus and menu closures
def ATTACKER_ON_LEFT = true     // Used with attack and showOutcome closures to indicate whether the attacker is on the left or right side of the screen/ring
def MAX_OUTCOME_DAMAGE = 6       // Maximum damage shown visually out the attack outcome meter
def OUTCOME_METER_SIZE = 20      // Number of blocks displayed on each side of the attack outcome meter
def OUTCOME_METER_COLOR = "#b380ff"    // Color of the attack outcome meter (medium violet)
def OUTCOME_METER_CHAR = "&bull;"      // Character to display on each block of the attack outcome meter
def COLOR_FIGHTERA = "#784421"       // Color of fighter A text (brown)
def COLOR_FIGHTERB = "#0000ff"     // Color of fighter B text (blue)
int FIGHT_LENGTH = 4 * 60          // the length of a fight in seconds  (4 minutes)
def TIE_REMATCH_LIMIT = 3       // the maximum number of times we allow a fight between the same two fighters to end in a tie
def PRACTICE_THRESHOLD = 3      // Number of skill units human can acquire during each practice session
def PRACTICE_SESSIONS = 3       // Number of practice sessions allowed before the Level 1 fight
int PRE_FIGHT_WAITING_PERIOD = 24 * 60 * 60 // Minimum amount of time human player must wait before each fight, in seconds (24 hours)
def UNRESPONSIVE_THRESHOLD = 20 // If during a fight, player is unresponsive for this many seconds or longer, player forfeits the fight
def SAVE_STRING = "sexopolis_fight_arena."  // Prefix used when saving values to the data registry
def FIGHTER_TYPE = [human:"human", coach:"coach", computer:"computer"]   // The three different types of fighters
def ATTACK_TYPE = [arms:"Punch",                    // The different types of attacks that a fighter can make
                   legs:"Kick",
                   body:"Bodyslam",
                   target:"Go for Target",
                   rest:"Rest"]
def DEFAULT_COACH_NAME = "Tara"                                      // The default name for the coach
def DEFAULT_PIC_COACH = "default_coach.png"                          // the default image to use for the coach
def COACH_NUM = 0                                                    // Fighter number of the coach
def DEFAULT_PLAYER_NUM = 1                                           // Default fighter number of the human player (used during practice)
def FIGHTER_LEVEL_KEYSTRING = "fighter_level"                        // Used to reference fighter level keys in DEFAULT_PICS
def DEFAULT_PICS = [coach:           DEFAULT_PIC_COACH,             // These are the default images to use for the coach and fighters
                    fighter_level01: "default_fighter_level01.png",
                    fighter_level02: "default_fighter_level02.png",
                    fighter_level03: "default_fighter_level03.png",
                    fighter_level04: "default_fighter_level04.png",
                    fighter_level05: "default_fighter_level05.png",
                    fighter_level06: "default_fighter_level06.png",
                    fighter_level07: "default_fighter_level07.png",
                    fighter_level08: "default_fighter_level08.png",
                    fighter_level09: "default_fighter_level09.png",
                    fighter_level10: "default_fighter_level10.png"]
def DEFAULT_PUNISHMENT_VALUE = true    // Punishments which the user has permitted during game play (defaults)
def DEFAULT_PUNISHMENTS_PERMITTED = [ballbusting:    [label: "Ballbusting",    permitted: DEFAULT_PUNISHMENT_VALUE],   
                                     nipple_torture: [label: "Nipple Torture", permitted: DEFAULT_PUNISHMENT_VALUE],
                                     spanking:       [label: "Spanking",       permitted: DEFAULT_PUNISHMENT_VALUE]]
def DEFAULT_UNKNOWN_ATTRIBUTES = ["speed", "strength", "recupSkill", "attSkillArms", "attSkillLegs", "attSkillBody", // attributes, which, by default
            "attSkillTarget", "defSkillArms", "defSkillLegs", "defSkillBody", "defSkillTarget"]  // for opponents and coach, will be displayed to user as "unknown"
def SKILL_LIST = ["recupSkill", "attSkillArms", "attSkillLegs", "attSkillBody",                    // List of skills
            "attSkillTarget", "defSkillArms", "defSkillLegs", "defSkillBody", "defSkillTarget"]
def ATTRIBUTES_TO_DISPLAY = [[name:           "Name",                   // Fighter attributes displayed to user (others remain hidden)
                              you:            "This is",                // organized into groups for display purposes
                              dopeLevel:      "Dope reduces speed by"],
                             [speed:          "Speed (innate)",
                              strength:       "Strength (innate)",
                              recupSkill:     "Recuperating Skill"],
                             [attSkillArms:   "Punching Skill",
                              attSkillLegs:   "Kicking Skill",
                              attSkillBody:   "Bodyslamming Skill",
                              attSkillTarget: "Target Skill"],
                             [defSkillArms:   "Punching Defense Skill",
                              defSkillLegs:   "Kicking Defense Skill",
                              defSkillBody:   "Bodyslamming Defense Skill",
                              defSkillTarget:  "Target Defense Skill"]]
def TOURNAMENT_STATUS = [not_in:                 "Not currently in tournament",      // Where the user is in the game play
                         practicing:             "Practicing",
                         awaiting_fight_start:   "Waiting for fight time",
                         fight_when_ready:       "Fight when ready",
                         fight_started:          "Fight forfeit by leaving",
                         fight_lost_do_favors:   "Performing favors as fight loser",
                         fight_won_get_favors:   "Receiving favors as fight winner"]
def STARTING_FAVOR_CHOICES = [ssr:       "find out the speed, strength, and recuperating skill of",     // Choices available for favors
                              attSkills: "find out the attack skills of",
                              defSkills: "find out the defense skills of"]
def FAVOR_ADMINISTER_DOPE = [administer_dope: "administer dope to"]
def FAVOR_GET_DOPE = [get_dope: "give me a dope capsule"]
def FAVOR_CHOICE = STARTING_FAVOR_CHOICES + FAVOR_ADMINISTER_DOPE + FAVOR_GET_DOPE
def PUNISHMENT_UNITS = 10    // Number of units of punishment user will receive in each punishment session
def DOPE_CAPSULES_PER_LEVEL = [1: 1,     // Number of dope capsules which defeated computer opponent will have to offer at each level
                               2: 1,     // Also used to determine how much dope a computer player administers to an opponent
                               3: 1,
                               4: 1,
                               5: 1,
                               6: 2,
                               7: 2,
                               8: 3,
                               9: 3,
                               10: 3]
def HEALTH_MESSAGES = [               // Descriptions of a fighter's health (from 0 to 10)
	"In extreme pain and completely wiped out, practically crawling",
	"In major pain, extremely tired and dizzy, but still standing",
	"In major pain, very tired, and obviously dizzy",
	"In pain, very tired, and showing weak form",
	"In pain, slightly tired, and showing weak form",
	"In slight pain, showing mediocre form",
	"In slight pain, showing good form",
	"Energetic, showing good form",
	"Energetic, showing excellent form",
	"Very energetic, showing excellent form",
	"Fully energetic, showing excellent form" ]
def HEALTH_COLORS = [              // Hexadecimal colors for a fighter's health (from 0 to 10 corresponds to red going to orange going to yellow going to green)
	"#ff0000",          // red
	"#ff2a00",
	"#ff5400",
	"#ff7e00",
	"#ffa800",
	"#ffd200",
	"#fffc00",          // yellow
	"#d8ff00",
	"#aeff00",
	"#84ff00",
	"#00ff00" ]         // green
                         
// ######################################################## GLOBAL VARIABLES ########################################################
// (stored in a map so that we are always aware that they are in fact global in scope)
                                                                            // when two computer-controlled fighters fight,
def GLOBAL = [current_fight_length:  FIGHT_LENGTH,                          //   we don't want to wait for pauses, so we reduce fight length instead
              pics:                  DEFAULT_PICS,                   // the filenames of the pictures to use for the coach and fighters
              punishments_permitted: DEFAULT_PUNISHMENTS_PERMITTED,   // Punishments which the user has permitted during game play
              tournament_num:        0,                    // The current or most recently completed tournament number
              fighter_left:          null,                 // The fighter on the left side of the ring
              fighter_right:         null,                 // The fighter on the right side of the ring
              coach:                 null,                 // The coach
              fight_level:           0,                    // Current fight level
              fight_levels_completed:0,                    // Number of fight levels that have been successfully completed
              num_competitors_remaining: NUM_COMPETITORS,  // Number of competitors, including human fighter, remaining in the tournament
              practice_sessions_completed: 0,              // Number of practice sessions completed in the current tournament
              countdown_start_time:  0,                    // Time at which countdown begun to start next fight
              current_tournament_status: TOURNAMENT_STATUS.not_in,      // Status of the current tournament
              num_ties:              0,                    // Number of ties at the current fight level
              tournaments_won:       0,                    // Number of tournaments won
              tournaments_lost:      0,                    // Number of tournaments lost
              favors_completed:      0,                    // Number of favors fight loser has completed for the fight winner
              favor_choices:         [],                   // Favor choices remaining for the victor to choose from
              dope_inventory:        0,                    // Number of dope capsules that the human player possesses
              dope_available:        0]                    // Number of dope capsules currently available from defeated computer fighter
              
// ######################################################## CLOSURES ########################################################

// Saves key to the registry with indicated value. key is prefixed with SAVE_STRING
def fa_save = {
    key, value ->
    save(SAVE_STRING + key, value)
}

// Returns an integer value between min and max, inclusive
def rand = {
	min, max ->
	return min + getRandom(max - min + 1)
}

// Displays a menu screen with various options for the user to choose from
// image_filename is a closure which should return the filename of the image that will be displayed
// message is a closure which should return the message text that will be displayed
// action_list is a closure which should return a list of maps. Each map should have a label key and an action key. Example map:
//     [label: "Choose this option", action: named_closure ]
// Optionally, a map can include an args key which will supply a single argument to the action when the action is executed. Example map with argument:
//     [label: "Choose this option", action: named_closure_which_accepts_single_argument, args: 3 ]
//     In this example, if the user chooses this option, the closure will be executed thusly: named_closure_which_accepts_single_argument(3)
// The last map in the action_list will always exit the menu
// set stay_put to !STAY_PUT if you only want the menu displayed once
def menu = {
    action_list, image_filename, message, stay_put = STAY_PUT ->
    def actionList
    def choiceList = []
    def playerChoice = 0
    def count = 0
    while (playerChoice != choiceList.size()-1 && (stay_put || count == 0)) {      // loop while the user hasn't chosen to quit, unless stay_put was false and
        setImage(image_filename())                                                    // went through loop once already
        def constructed_message = message()
        actionList = action_list()
        choiceList = actionList.label        
        playerChoice = getSelectedValue(constructed_message, choiceList)
        def args = { if (actionList[playerChoice].containsKey("args")) { 
                            return actionList[playerChoice]["args"]
                        } else {
                            return null
                        }
                   }
        actionList[playerChoice]["action"](args())
        count++
    }    
}


// Returns true if MESSAGE_MODE is "all" and one of the two fighters is human
def shouldShowMessages = {
    fighterA, fighterB ->
    return (MESSAGE_MODE == "all" && (fighterA.isHuman || fighterB.isHuman))
}

// Returns a map with text and sound keys describing the result of a successful attack made with the arms or hands
def armAttackMessage = {
	attacker, defender, damage ->
	switch (damage) {
		case 1..2:
			return [text:attacker.you + " punch" + attacker.es + " " + defender.you_lc + ".", sound: FOLDER_NAME + "punch1punch.mp3"]
		case 3..5:
			return [text:attacker.you + " punch" + attacker.es + " " + defender.you_lc + " hard in the belly, making " + defender.you_lc + 
                    " grunt in pain.", sound: FOLDER_NAME + "punch2grunt_high.mp3"]
		default:
			return [text:attacker.you + " land" + attacker.s + " a powerful punch directly on the chin. " + defender.you + " lose" + defender.s + " footing and reel" +
					defender.s + " in pain!!", sound: FOLDER_NAME + "punch3_high.mp3"]
	}
}

// Returns a map with text and sound keys describing the result of a successful attack made with the legs or feet
def legAttackMessage = {
	attacker, defender, damage ->
	switch (damage) {  
		case 1..2:
			return [text: attacker.you + " kick" + attacker.s + " " + defender.you_lc+ ".", sound: FOLDER_NAME + "kick1kick.mp3"]
		case 3..5:
			return [text: attacker.you + " knee" + attacker.s + " " + defender.you_lc+ " forcefully in the gut, making " +
                    defender.you_lc + " cry out in pain.", sound: FOLDER_NAME + "kick2cry_high.mp3"]
		default:
			return [text: attacker.you + " land" + attacker.s + " a brutal roundhouse kick on the head. " + defender.you + " stagger" + defender.s + " and groan" +
					defender.s + " in agony!!", sound: FOLDER_NAME + "kick3groan_high.mp3"]
	}
}			

// Returns a map with text and sound keys describing the result of a successful attack made with the body
def bodyAttackMessage = {
	attacker, defender, damage ->
	switch (damage) {  
		case 1..2:
			return [text: attacker.you + " shoulder" + attacker.s + " " + defender.you_lc+ ".", sound: FOLDER_NAME + "bodyslam1shoulder.mp3"]
		case 3..5:
			return [text: attacker.you + " plow" + attacker.s + " into " + defender.you_lc + ", making " + defender.you_lc + " yelp in pain.",
                    sound: FOLDER_NAME + "bodyslam2yelp_high.mp3"]
		default:
			return [text: attacker.you + " robustly bodyslam" + attacker.s + " " + defender.you_lc + ", making " + defender.you_lc +
                    " lose balance and moan in great anguish!!", sound: FOLDER_NAME + "bodyslam3moan_high.mp3"]
	}
}	

// Returns a string describing the amount of recuperation
def recupMessage = {
	attacker, amount ->
	switch (amount) {
		case 0:
			return attacker.you + " rest" + attacker.s + "."  
		case 1:
			return attacker.you + " recuperate" + attacker.s + " slightly."
		case 2..4:
			return attacker.you + " " + attacker.have + " a burst of energy."
		default:
			return attacker.you + " rest" + attacker.s + " briefly; a great surge of energy brings " + attacker.you_lc + " back into the fight!!"
	}
}	

// Returns a string describing the adjustment to the recuperation amount
def recupAdjMessage = {
	attacker, defender, amount ->
	switch(amount) {
		case 0:
			return ""
		case -3..-1:
			return defender.you + " seem" + defender.s + " to sense your sluggishness...<br>"
		default:
			return attacker.you + " seem" + attacker.s + " to be in an unwary daze... " + defender.you + " circle" + defender.s + " like a hawk...<br>"
	}
}

// Returns a string describing the adjustment to the attack score
def attackScoreAdjMessage = {
	defender, adjAmount ->
	switch(adjAmount) {
		case 1:
			return "Lightning attack!<br>"
		case 0:
			return ""
		case -3..-1:
			return defender.you + " see" + defender.s + " your attack coming...<br>"
		default:
			return defender.you + " can see your ponderous, clumsy move coming from a mile away...<br>"
	}
}

 // Plays background sound, but only if messages should be shown   
 def playBGSound = {
    file_name, fighterA, fighterB ->
    if (shouldShowMessages(fighterA, fighterB)) {
        playBackgroundSound(file_name)
    }
 }   
    
// Returns a time string in the form mm:ss  (minutes and seconds)
def timeString = {
	timeInSeconds ->
	if (timeInSeconds < 0) {
		timeInSeconds = 0
	}
	int minutes = timeInSeconds / 60
	int seconds = timeInSeconds % 60
	def minutesExtraDigit = ""
	if (minutes < 10) {
		minutesExtraDigit = "0"
	}
	def secondsExtraDigit = ""
	if (seconds < 10) {
		secondsExtraDigit = "0"
	}
	return minutesExtraDigit + minutes + ":" + secondsExtraDigit + seconds
}

// Returns string indicating in approximately how many hours or minutes the next fight will start
// Changes the current tournament status to fight_when_ready if appropriate
def fight_start_time_string = {
    int elapsedTime = getTime() - GLOBAL.countdown_start_time
    int seconds_until_fight = PRE_FIGHT_WAITING_PERIOD - elapsedTime
    
    if (seconds_until_fight <= 0) {
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.fight_when_ready
        fa_save("current_tournament_status", GLOBAL.current_tournament_status)
        return "whenever you are ready"
    }
    if (seconds_until_fight < 15) {
        return "in less than 15 seconds"
    }
    if (seconds_until_fight < 30) {
        return "in fewer than 30 seconds"
    }
    if (seconds_until_fight < 60) {
        return "in under a minute"
    }
    int minutes_until_fight = Math.round(seconds_until_fight / 60)
    if (minutes_until_fight < 2) {
        return "in under 2 minutes"
    }
    if (minutes_until_fight < 91) {
        return "in about " + minutes_until_fight + " minutes"
    }
    int hours_until_fight = Math.round(minutes_until_fight / 60)
    return "in about " + hours_until_fight + " hours"
}


// Returns level as a two-character string (including leading 0 if necessary e.g. levelString(1) returns "01")
def levelString = {
    level ->
    def extraDigit = ""
    if (level < 10) {
        extraDigit = "0"
    }
    return extraDigit + level
}

// Returns a string including the value followed by a space then the word with or without an 's' as appropriate
// e.g.  showS("banana", 2) returns "2 bananas"
//       showS("banana", 1) returns "1 banana"
def showS = {
	word, value ->
	if (value == 1) {
		return value + " " + word
	} else {
		return value + " " + word + "s"
	}
}


// Displays the status of each fighter. If one of the fighters is human and has priority, an "Act" button will be displayed.
// Human's priority will decrease if button is not clicked quickly. 
// stayPut should be STAY_PUT or !STAY_PUT; if STAY_PUT then the status will be displayed until user continues
// startTime is the time that the fight started
def showStatus = {
	fighterA, fighterB, stayPut, startTime ->
	def readyToContinue = false      // This closure is a big loop. When we're ready to leave the loop and continue on with the script, this will be set to true
	int timeRemaining                // How much time is left on the fight clock
	def hereStartTime = getTime()    // Time that we started this closure
	int elapsedTime                  // Amount of time elapsed since this closure was started
	while (!readyToContinue) { 
		timeRemaining = GLOBAL.current_fight_length - Math.floor(getTime()-startTime)         // Calculate how much time is left on the fight clock
		show("<p style=\"font-size:1.5em;text-align:center\">" + timeString(timeRemaining) + "</p>" +
			"<table><tr><th style=\"color:" + COLOR_FIGHTERA + "\">" + fighterA.you + "</th><th style=\"color:" + COLOR_FIGHTERB + "\">" + fighterB.you + "</th></tr>" +
	         "<tr><td style=\"color:" + COLOR_FIGHTERA + ";text-align:center\">" + showS("point", fighterA.points) + "</td>" +
	             "<td style=\"color:" + COLOR_FIGHTERB + ";text-align:center\">" + showS("point", fighterB.points) + "</td></tr>" +
	         "<tr><td style=\"color:" + COLOR_FIGHTERA + ";\">" + HEALTH_MESSAGES[fighterA.health] + "</td>" +
	             "<td style=\"color:" + COLOR_FIGHTERB + ";\">" + HEALTH_MESSAGES[fighterB.health] + "</td></tr>" +
			 "<tr><td style=\"background-color:" + HEALTH_COLORS[fighterA.health] + ";\"></td>" + 
			 	 "<td style=\"background-color:" + HEALTH_COLORS[fighterB.health] + "\"></td></tr></table>")
		if (stayPut) {
			wait(PAUSE_AMOUNT)
			showButton("----------------Okay----------------")
			readyToContinue = true                // end the loop if the button has been pressed
		} else {
			def time_to_act = PAUSE_AMOUNT        // how long it took human player to click on the "Act" button (only displayed if the human player has priority)
		
			if ((fighterA.isHuman && fighterA.priority > fighterB.priority) ||   // 2nd comparison is consistent with the one in fight closure
				(fighterB.isHuman && fighterB.priority >= fighterA.priority)) {  // 2nd comparison is logically consistent with else in fight closure
				time_to_act = showButton("Act", 1)                                       // returns either 1 or the number of seconds to act
				if (time_to_act < 1) {
					readyToContinue = true                                        // end the loop if the human acts
				}
				elapsedTime = Math.floor(getTime()-hereStartTime)
				int priorityDecrement = Math.floor(elapsedTime / PAUSE_AMOUNT) 
				if (fighterA.isHuman) {
					fighterA.priority -= priorityDecrement                        // you lose priority if you haven't acted
					if (fighterA.priority <= fighterB.priority) {                 // end the loop if the human has lost priority
						readyToContinue = true
					}
				}
				if (fighterB.isHuman) {
					fighterB.priority -= priorityDecrement                         // you lose priority if you haven't acted
					if (fighterB.priority < fighterA.priority) {                  // end the loop if the human has lost priority
						readyToContinue = true
					}
				}
			} else {             	// wait PAUSE_AMOUNT seconds if there is no human fighter or if the computer fighter has greater priority to begin with
				wait(1)
				elapsedTime = Math.floor(getTime()-hereStartTime)
				if (elapsedTime >= PAUSE_AMOUNT) {
					readyToContinue = true                                  // end the loop if the status message has been displayed for at least PAUSE_AMOUNT seconds
				}
			}
		}
	}
}

// Display the outcome of an attack
// attScore: the attack score
// defScore: the defense score
// damage: the amount of damage
// attacker_on_left: should be true if attacker is on the left side of the screen, false if on the right
def showOutcome = {
	message, attScore, defScore, damage, attacker_on_left, fighterA, fighterB ->
	if (shouldShowMessages(fighterA, fighterB)) {
		def damageColor
		def damageColorList = ["black", "#ffd200", "#ffa800", "#ff7e00", "#ff5400", "#ff2a00", "#ff0000"]   // damage colors going from yellow to orange to red
		def hitAmount = attScore - defScore        // the amount by which the attacker hit; 0 or less is a miss
		def numAttBlocks                           // how many filled blocks to display on the attacker's side of the meter (the greater the miss, the fewer blocks)
		def numAttGaps                             // how many gap blocks to display on the attacker's side of the meter
		def numDefBlocks                           // how many filled blocks to display on the defender's side of the meter (the greater the hit, the more blocks)
		def numDefGaps                             // how many gap blocks to display on the defender's side of the meter
		def outcomeMessage

		if (damage < 0) {
			damage = 0
		}
		if (damage > MAX_OUTCOME_DAMAGE) {
			damage = MAX_OUTCOME_DAMAGE
		}
		damageColor = damageColorList[damage]                  // the color of the damage block is determined by the amount of damage

		numAttBlocks = hitAmount + (OUTCOME_METER_SIZE - 1)    // if hitAmount is positive, there will be OUTCOME_METER_SIZE blocks
		if (numAttBlocks > OUTCOME_METER_SIZE) {
			numAttBlocks = OUTCOME_METER_SIZE
		}
        if (numAttBlocks < 0) {
            numAttBlocks = 0
        }
		numAttGaps = OUTCOME_METER_SIZE - numAttBlocks         // This fills the gap between the attacker blocks and the target in the middle
		numDefBlocks = hitAmount - 1                     // if hitAmount is 1 or less, there will be no blocks
		if (numDefBlocks < 0) {
			numDefBlocks = 0
		}
        if (numDefBlocks > OUTCOME_METER_SIZE) {               // Don't allow more than OUTCOME_METER_SIZE defender blocks
            numDefBlocks = OUTCOME_METER_SIZE
        }
		numDefGaps = OUTCOME_METER_SIZE - numDefBlocks         // This fills the gap between the defender blocks and the edge
		
		def meterListBlocks                              // Each item of this list represents a segment of the meter; the # of blocks that make up that segment
		def meterListColors                              // Each item of this list represents a segment of the meter; the color of blocks that make up that segment

		// The segments to display if the attacker is on shown on the left side of the screen
		def leftListBlocks = [numAttBlocks, numAttGaps, 1, numDefBlocks, numDefGaps]
		def leftListColors = [OUTCOME_METER_COLOR, "transparent", damageColor, OUTCOME_METER_COLOR, "transparent"]

		// The segments to display if the attacker is on shown on the right side of the screen
		def rightListBlocks = [numDefGaps, numDefBlocks, 1, numAttGaps, numAttBlocks]
		def rightListColors = ["transparent", OUTCOME_METER_COLOR, damageColor, "transparent", OUTCOME_METER_COLOR]

		if (attacker_on_left) {
			meterListBlocks = leftListBlocks
			meterListColors = leftListColors
		} else {
			meterListBlocks = rightListBlocks
			meterListColors = rightListColors
		}

		// METER DISPLAY
		outcomeMessage = "<p style=\"text-align:center\"><br>"                              // Start the meter
		for (def j = 0; j < meterListBlocks.size(); j++) {                                  // iterate over the segments of the meter
			for (def i = 1; i <= meterListBlocks[j]; i++) {                                  // for each segment, display the # of blocks in the designated color
				outcomeMessage += "<span style=\"background-color:" + meterListColors[j] + "\">" + OUTCOME_METER_CHAR + "</span>"
			}
		}
		outcomeMessage += "</p>"                                                                          // End the meter
		
		show("<p style=\"text-align:center\">" + message + "</p>" + outcomeMessage)		
		wait(PAUSE_AMOUNT)

	} else {
        GLOBAL.current_fight_length -= PAUSE_AMOUNT
    }
}


// Have a computer player choose an action for an attack; returns one of ATTACK_TYPE values
def chooseAttackTypeComp = {
	attacker, defender ->
	//The attacker can choose one of the ATTACK_TYPE values for the attack
    def attackType                // Will be assigned one of ATTACK_TYPE values
    def attackOptionsSpread = []  // This will be a list of attack options, from which one will be chosen randomly
    def attackOptionsChoice       // This is the index of the chosen item from attackOptionsSpread
    
    
    if (attacker.health <= REST_THRESHOLD) {
		attackType = ATTACK_TYPE.rest
    } else {
        // Add attack options to the attackOptionsSpread.
        // The higher a particular skill, the more times it is added to the spread, thereby increasing its chance of being chosen later
        for (i in 1..(ATTACK_OPTIONS_BASE + attacker.attSkillArms)) {
            attackOptionsSpread << ATTACK_TYPE.arms
        }
        for (i in 1..(ATTACK_OPTIONS_BASE + attacker.attSkillLegs)) {
            attackOptionsSpread << ATTACK_TYPE.legs
        }
        for (i in 1..(ATTACK_OPTIONS_BASE + attacker.attSkillBody)) {
            attackOptionsSpread << ATTACK_TYPE.body
        }
        for (i in 1..(ATTACK_OPTIONS_BASE + attacker.attSkillTarget + attacker.health - defender.health)) { 
            attackOptionsSpread << ATTACK_TYPE.target // by adding in the difference between the attacker's and defender's health, we increase the likelihood of
                                                      //    attacking the target when defender is weak relative to the attacker and decrease the likelihood when
                                                      //    defender is strong relative to attacker 
        }  
        // Randomly choose one of the options in attackOptionsSpread
        attackOptionsChoice = rand(1, attackOptionsSpread.size) - 1
        attackType = attackOptionsSpread[attackOptionsChoice]
    }
	return attackType
}

// Have a human player choose an action for an attack; returns one of ATTACK_TYPE values
// If supplied, type should be one of the ATTACK_TYPE values and only that choice will be presented to the player
def chooseAttackTypeHuman = {
    type = null ->
    def playerChoice
    if (type == null) {
        def choiceList = []
        for (attack_type in ATTACK_TYPE) {
            choiceList += attack_type.value
        }
        playerChoice = getSelectedValue("Choose an action:", choiceList)
        return choiceList[playerChoice]
    } else {
        playerChoice = getSelectedValue("Choose an action:",[type])
        return type
    }
}


// Shows the fighter attributes, with supplemental heading if supplied
def view_fighter_attributes = {
    supplemental_heading = null ->
    def fighterList = [GLOBAL.fighter_left, GLOBAL.fighter_right]
    def result = "<h1 style=\"text-align:center\">Fighter Attributes"
    if (supplemental_heading != null) {
        result += ", " + supplemental_heading
    }
    result += "</h1><table style=\"border-spacing: 0;\">"
    def keyList = []
    def colorList = [COLOR_FIGHTERA, COLOR_FIGHTERB]
    def value
    def iter = 0
    for (group in ATTRIBUTES_TO_DISPLAY) {
        result += "<tr style=\"border:1px solid black\"><td>"
        keyList = []
        for ( attrib in group ) {                                            // Attribute labels
            result += attrib.value + "<br>"
            keyList += attrib.key
        }
        iter = 0
        for (fighter in fighterList) {                                                       // Attribute values for each fighter
            result += "</td><td style=\"color:" + colorList[iter] + "\">"
            iter++
            for ( key in keyList ) {
                if (key in fighter.unknown) {     // Check the unknown list and display "Unknown" if the user should not see this attribute value
                    value = "Unknown"
                } else {
                    if (key == "isHuman") {
                        if (fighter[key]) {
                            value = "true"
                        } else {
                            value = "false"
                        }
                    } else {
                        value = fighter[key]
                    }                
                }
                result += value + "<br>"
            }
        }
        result += "</tr>"
    }
    result += "</table>"
    show(result)
    showButton("Okay")
}

// fighter possibly dopes opponent, depending on the fight level and the relative speeds of the two fighters
def dope_opponent = {
    fighter, opponent, fight_level ->
    def dope_amount                  // the number of dope capsules administered to opponent
    if (fight_level == NUM_FIGHT_LEVELS) {
        dope_amount = DOPE_CAPSULES_PER_LEVEL[NUM_FIGHT_LEVELS]
    } else {
        dope_amount = opponent.speed - fighter.speed + DOPE_CAPSULES_PER_LEVEL[fight_level]
        if (dope_amount < 0) {
            dope_amount = 0
        }
        if (dope_amount > DOPE_CAPSULES_PER_LEVEL[fight_level]) {
            dope_amount = DOPE_CAPSULES_PER_LEVEL[fight_level]
        }
    }
    opponent.dopeLevel = dope_amount
}


// Carries out an attack by attacker against defender. attacker_on_left should be true if the attacker is displayed on the left side of the screen, false otherwise
// If type is provided, it should be one of ATTACK_TYPE values
def attack = {
	attacker, defender, attacker_on_left, type = null ->

	def attackType              // The type of attack chosen by the attacker, one of ATTACK_TYPE values
	def attackScoreAdj = 0      // An adjustment to the attack score for a human player based on how quickly the player chooses an attack type
	def recupAmountAdj = 0      // An adjustment to the recuperation amount for a human player based on how quickly the player chooses to rest
    def outcomeMessage = ""    // A message describing the outcome of the attack
	def attackScore         // The attacker will get an attack score
    def defenseScore        // The defender will get a defense score
    int damageAmount        // Amount of damage to defender's health if attack is successful
    def targetAct           // Used to determine if, when target button is pressed, it is activated (thereby scoring the attacker a point)
	def recupAmount         // When attackType is ATTACK_TYPE.rest, used to determine amount of health the attacker recuperates

    attacker.priority -= (MAX_SPEED - (attacker.speed - attacker.dopeLevel) + 1)     // the attack uses up some of the attacker's priority

	if (attacker.isHuman && MESSAGE_MODE == "all") {
		def startTime = getTime()
		attackType = chooseAttackTypeHuman(type)                      // Human player
		int elapsedTime = Math.floor(getTime()-startTime)         // Calculate number of seconds it took the player to choose an attack
		attackScoreAdj = 1 - elapsedTime                          // Lower attack score for choosing slowly; increase for choosing quickly (doesn't apply to rest)
		if (elapsedTime > 1) {
			attacker.priority -= (elapsedTime - 1)               // Lower priority for choosing slowly
			recupAmountAdj = 1 - elapsedTime                     // Lower the recuperation amount for choosing slowly  (only applies to rest)
            if (elapsedTime > UNRESPONSIVE_THRESHOLD && defender.num != 0) {   // If the player took a really long time to respond [unless defender is coach]
                attackType = "fighter_idle"                                    //   (possibly trying to wait out the  fight as a way of cheating), fight is forfeit
            }
        } else {
			recupAmountAdj = 0                                   // No recuperation bonus for choosing quickly
		}
		if (attackType == ATTACK_TYPE.rest) {                            
			outcomeMessage = recupAdjMessage(attacker, defender, recupAmountAdj)    // say something about recuperation amount adjustment, if any
		} else {
			outcomeMessage = attackScoreAdjMessage(defender, attackScoreAdj)        // say something about attack score adjustment, if any
		}
		
	} else {
        if (type == null) {
            attackType = chooseAttackTypeComp(attacker, defender)    // Automated computer player
        } else {
            attackType = type                                        // Automated computer player, but attack type supplied in advance
        }
	}

    // Now that an attack type has been chosen, carry out that type of attack
	switch(attackType) {
		case ATTACK_TYPE.arms:
			attackScore = rand(0, attacker.attSkillArms) + rand(0, ATTACK_OPTIONS_BASE) + attackScoreAdj
            defenseScore = rand(0, defender.defSkillArms) + rand(0, ATTACK_OPTIONS_BASE)
            if (attackScore > defenseScore) {              // The attack is successful
				attacker.attSkillArms++                    // Gain experience for a successful attack 
                damageAmount = rand(1, attacker.strength)  // The stronger the attacker is, the higher the damage is likely to be
                defender.health -= damageAmount            // Decrease the defender's health
                if (defender.health < MIN_HEALTH) {        // Don't allow health below MIN_HEALTH
                    defender.health = MIN_HEALTH
                }
                defender.priority -= damageAmount          // The defender is stunned by the blow, so we reduce their priority level as well
                def attackMessage = armAttackMessage(attacker, defender, damageAmount)
				outcomeMessage += attackMessage.text
                playBGSound(attackMessage.sound, attacker, defender)
            } else {
                defender.defSkillArms++                   // The defender gains experience for successfully defending against an attack
				outcomeMessage += attacker.you + " take" + attacker.s + " a swing at " + defender.you_lc + " but fail" + attacker.s + " to connect."
            }
			showOutcome(outcomeMessage, attackScore, defenseScore, damageAmount, attacker_on_left, attacker, defender)
            break
		case ATTACK_TYPE.legs:
			attackScore = rand(0, attacker.attSkillLegs) + rand(0, ATTACK_OPTIONS_BASE) + attackScoreAdj
            defenseScore = rand(0, defender.defSkillLegs) + rand(0, ATTACK_OPTIONS_BASE)
            if (attackScore > defenseScore) {              // The attack is successful
				attacker.attSkillLegs++                    // Gain experience for a successful attack 
                damageAmount = rand(1, attacker.strength)  // The stronger the attacker is, the higher the damage is likely to be
                defender.health -= damageAmount            // Decrease the defender's health
                if (defender.health < MIN_HEALTH) {        // Don't allow health below MIN_HEALTH
                    defender.health = MIN_HEALTH
                }
                defender.priority -= damageAmount          // The defender is stunned by the blow, so we reduce their priority level as well
                def attackMessage = legAttackMessage(attacker, defender, damageAmount)
				outcomeMessage += attackMessage.text
                playBGSound(attackMessage.sound, attacker, defender)
            } else {
                defender.defSkillLegs++                   // The defender gains experience for successfully defending against an attack
				outcomeMessage += attacker.you + " attempt" + attacker.s + " to kick " + defender.you_lc + " but " + defender.you_lc + " evade" +
								defender.s + " the blow."
            }
			showOutcome(outcomeMessage, attackScore, defenseScore, damageAmount, attacker_on_left, attacker, defender)
            break
		case ATTACK_TYPE.body:
			attackScore = rand(0, attacker.attSkillBody) + rand(0, ATTACK_OPTIONS_BASE) + attackScoreAdj
            defenseScore = rand(0, defender.defSkillBody) + rand(0, ATTACK_OPTIONS_BASE)
            if (attackScore > defenseScore) {              // The attack is successful
				attacker.attSkillBody++                    // Gain experience for a successful attack 
                damageAmount = rand(1, attacker.strength)  // The stronger the attacker is, the higher the damage is likely to be
                defender.health -= damageAmount            // Decrease the defender's health
                if (defender.health < MIN_HEALTH) {        // Don't allow health below MIN_HEALTH
                    defender.health = MIN_HEALTH
                }
                defender.priority -= damageAmount          // The defender is stunned by the blow, so we reduce their priority level as well
                def attackMessage = bodyAttackMessage(attacker, defender, damageAmount)
				outcomeMessage += attackMessage.text
                playBGSound(attackMessage.sound, attacker, defender)
            } else {
                defender.defSkillBody++                   // The defender gains experience for successfully defending against an attack
				outcomeMessage += attacker.you + " make" + attacker.s + " a move to bodyslam " + defender.you_lc + " but meet" + attacker.s + " air."
            }
			showOutcome(outcomeMessage, attackScore, defenseScore, damageAmount, attacker_on_left, attacker, defender)
            break
		case ATTACK_TYPE.target:
			attackScore = attacker.health + rand(1, attacker.attSkillTarget + 1) + attackScoreAdj    // Ability to reach target depends on attacker's health and skill
			defenseScore = defender.health + rand(1, defender.defSkillTarget + 1)   // Ability to defend target depends on defender's health and skill
            if (attackScore > defenseScore) {              // The attack is successful
				attacker.attSkillTarget++                 // Gain experience for a successful attack 
                targetAct = rand(1, TARGET_ACT_CHANCE)     // Determine whether target button will be activated
				if (targetAct == 1) {
					attacker.points++                     // The target button was activated, scoring the attacker a point
					outcomeMessage += attacker.you + " lunge" + attacker.s + " for the points target and press" + attacker.es + " the button, scoring a point!!"
					damageAmount = MAX_OUTCOME_DAMAGE     // For visual representation of the outcome
					playBGSound(FOLDER_NAME + "point_scored.mp3", attacker, defender)
                } else {                                 // The target button was not activated; no point is scored
					outcomeMessage += attacker.you + " lunge" + attacker.s + " for the points target and press" + attacker.es + " the button, but no point is earned."
					damageAmount = 0                    // For visual representation of the outcome
					playBGSound(FOLDER_NAME + "target_pressed_no_point.mp3", attacker, defender)
				}
				
            } else {
                defender.defSkillTarget++                   // The defender gains experience for successfully defending against an attack
				outcomeMessage += attacker.you + " lunge" + attacker.s + " for the points target but " + defender.you_lc + " block" + defender.s + " " +
								attacker.you_lc + "."
				damageAmount = 0                    // For visual representation of the outcome
            }
			showOutcome(outcomeMessage, attackScore, defenseScore, damageAmount, attacker_on_left, attacker, defender)
            break
		case ATTACK_TYPE.rest:
			if (attacker.health == MAX_HEALTH || attacker.health == (MAX_HEALTH - 1)) {
				recupAmount = (MAX_HEALTH - attacker.health)
				if (recupAmount == 1 && recupAmountAdj < 0) {     // If human player was slow to choose rest option, they lose their recuperation
					recupAmount = 0
				}
			} else {
				recupAmount = rand(1,2) + rand(0, attacker.recupSkill)    // Recuperate 1 or 2 health plus possibly more if experienced at recuperating
				recupAmount += recupAmountAdj                             // Amount of recuperation is decreased if human player was slow to choose rest
				if (recupAmount < 0) {                                    // Don't allow a negative recuperation amount
					recupAmount = 0
				}
			}
			attacker.health += recupAmount
            if (attacker.health > MAX_HEALTH) {                     // Don't allow health above MAX_HEALTH
				   recupAmount -= (attacker.health - MAX_HEALTH)
                    attacker.health = MAX_HEALTH
                }			
			if (recupAmount >= 2) {
				attacker.recupSkill++                              // Gain experience for recuperating more than 1 health
            }
			outcomeMessage += recupMessage(attacker, recupAmount)
			if (shouldShowMessages(attacker, defender)) {
				show(outcomeMessage)
				wait(PAUSE_AMOUNT)
			} else {
                GLOBAL.current_fight_length -= PAUSE_AMOUNT
            }
            break
        case "fighter_idle":                                       // Human player took really long time to choose an attack type, so they forfeit the fight
            def pointDiff = 3 - defender.points
            defender.points = 3
            if (shouldShowMessages(attacker, defender)) {
                show("<b>TECHNICAL KNOCKOUT:</b> $attacker.name has become unresponsive and forfeits the fight. $defender.name is awarded $pointDiff points.")
                showButton("Drat!")
            }
            break
	}
}

// Show strings one per line, one at a time with pauses between each
// topList is the list of strings to display at the top of the screen
// leftList is the list of strings to display on the left middle area of the screen
// rightList is the list of strings to display on the right middle area of the screen
// bottomList is the list of strings to display at the bottom of the screen
def showByLine = {
	topList, leftList, rightList, bottomList ->
	def filler = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
	def listList = [topList, leftList, rightList, bottomList]     // put the lists in a superlist to make them easy to iterate through
	def strList = [filler, filler, filler, filler]                // we use this to build up the strings [0] is top, [1] is left, [2] is right, and [3] is bottom
	for (def i = 0; i < listList.size(); i++) {                   // iterate through the list of lists
		strList[i] = ""
		for (str in listList[i]) {                               // iterate through the strings in each list
			strList[i] += str + "<br>"                           // concatenate the string to the string we are building up
			show("<table><tr><td  colspan=\"2\" style=\"text-align:center\">" + strList[0] + "<br></td></tr>" +
				        "<tr><td style=\"text-align:center\">" + strList[1] + "</td>" +
					        "<td style=\"text-align:center\">" + strList[2] + "</td></tr>" +
				        "<tr><td colspan=\"2\" style=\"text-align:center\"><br>" + strList[3] +"</td></tr></table>")
							wait(PAUSE_AMOUNT)
		}
	 }
}

// Prepares a fighter to start a new fight (health, priority, and points are reset to pre-fight values)
def prepareFighterForFight = {
    fighter ->
    fighter.health = MAX_HEALTH
    fighter.priority = BASE_PRIORITY + fighter.speed - fighter.dopeLevel
    fighter.points = 0 
}

// Carries out a fight between fighterA and fighterB. Returns either "fighterA", "fighterB", or "tie", representing who the winner is
// optional level is the fight level in the tournament (determines which fighter image is displayed)
def fight = {
	fighterA, fighterB, level = null ->

    prepareFighterForFight(fighterA)
    prepareFighterForFight(fighterB)    
    if (shouldShowMessages(fighterA, fighterB)) {
        setImage(FOLDER_NAME + "fight_ring.png")
        playBackgroundSound(FOLDER_NAME + "introduce_fighters.mp3")
        showByLine(["________________________SEXOPOLIS FIGHT ARENA________________________"],
                   ["On the left side of the ring...",
                     "<span style=\"color:" + COLOR_FIGHTERA + "\">" + fighterA.name + "</span>"],
                   ["And on the right side of the ring...",
                     "<span style=\"color:" + COLOR_FIGHTERB + "\">" + fighterB.name + "</span>"],				
                   ["Let the fight begin!"])

        showButton("Start Fight")
        playSound(FOLDER_NAME + "start_fight_ding.mp3")
        setImage(FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)])
    }

    GLOBAL.current_fight_length = FIGHT_LENGTH
	int timeRemaining = GLOBAL.current_fight_length                   // how much time is left on the fight clock
	def startTime = getTime()                         // start the timer

	if (shouldShowMessages(fighterA, fighterB)) {
		showStatus(fighterA, fighterB, !STAY_PUT, startTime)               // show the current status of the fight and fighters
	} else {
        GLOBAL.current_fight_length -= 1         // when fight is automated, we don't want to wait it out in real time, so instead we reduce its length
    }
	timeRemaining = GLOBAL.current_fight_length - Math.floor(getTime()-startTime)         // Calculate how much time is left on the fight clock
	
	// The fight continues until one of the fighters reaches POINTS_TO_WIN or the fight clock has run out
	while (fighterA.points < POINTS_TO_WIN && fighterB.points < POINTS_TO_WIN && timeRemaining > 0) {
		if (fighterA.priority > fighterB.priority) {
			attack(fighterA, fighterB, ATTACKER_ON_LEFT)                 // If fighterA has priority then let fighterA attack fighterB
	    } else {
	        attack(fighterB, fighterA, !ATTACKER_ON_LEFT)                // If fighterB has priority then let fighterB attack fighterA
	    }
        timeRemaining = GLOBAL.current_fight_length - Math.floor(getTime()-startTime)         // Calculate how much time is left on the fight clock
		if (shouldShowMessages(fighterA, fighterB)) {
			if (fighterA.points < POINTS_TO_WIN && fighterB.points < POINTS_TO_WIN && timeRemaining > 0) {
				showStatus(fighterA, fighterB, !STAY_PUT, startTime)
			} else {
				playBGSound(FOLDER_NAME + "end_fight_ding.mp3", fighterA, fighterB)
				showStatus(fighterA, fighterB, STAY_PUT, startTime)
			}
		} else {
            GLOBAL.current_fight_length -= 1    // when fight is automated, we don't want to wait it out in real time, so instead we reduce its length
        }         
	}

	def result                   // result will be either "fighterA", "fighterB", or "tie", representing who the winner is
	def showString               // The results to display visually
	if (fighterA.points > fighterB.points) {
		result = "fighterA"
		showString = fighterA.name + " is the victor!"
	} else {
		if (fighterB.points > fighterA.points) {
			result = "fighterB"
			showString = fighterB.name + " is the victor!"
		} else {
			result = "tie"
			showString = "The fight is a tie!"
		}
	}
    if (shouldShowMessages(fighterA, fighterB)) {
        setImage(FOLDER_NAME + "fight_ring.png")
        playBackgroundSound(FOLDER_NAME + "fight_results.mp3")
        showByLine(["________________________FIGHT RESULTS________________________"],
                   ["<span style=\"color:" + COLOR_FIGHTERA + "\">" + fighterA.name + "</span>",
                    "<span style=\"color:" + COLOR_FIGHTERA + "\">" + showS("point", fighterA.points) + "</span>"],
                   ["<span style=\"color:" + COLOR_FIGHTERB + "\">" + fighterB.name + "</span>",
                    "<span style=\"color:" + COLOR_FIGHTERB + "\">" + showS("point", fighterB.points) + "</span>"],		
                   [showString])
        showButton("Continue")
    }

	return result	
}

// Returns a value between 1 and 10, generated randomly but more or less according to a standard bell curve distribution
// i.e. 38% chance value is 5 or 6, 68% chance value is between 4 and 7, 92% chance value is between 3 and 8, only 2% chance value is a 1 or 10
def generate_speed_or_strength = {
    int randValue = rand(1,100)
    switch (randValue) {
        case 1:       return 1     // 1%
        case 2..4:    return 2     // 3%
        case 5..16:   return 3     // 12%
        case 17..31:  return 4     // 15%
        case 32..50:  return 5     // 19%
        case 51..69:  return 6     // 19%
        case 70..84:  return 7     // 15%
        case 85..96:  return 8     // 12%
        case 97..99:  return 9     // 3%
        case 100:     return 10    // 1%
    }
}

// Changes the name  (and corresponding you and you_lc attributes) of the indicated fighter to newName
def changeFighterName = {
    fighter, newName ->
    fighter.name = newName
    if (!fighter.isHuman) {
        fighter.you = newName
        fighter.you_lc = newName
    }
}

// Changes the number (and corresponding name) of the indicated fighter to newNum 
def changeFighterNum = {
    fighter, newNum ->
    changeFighterName(fighter, "Fighter " + newNum)
    fighter.num = newNum
}


// Creates a new fighter with designated fighter number ready to fight a Level 1 fight (the first round or lowest tier)
// fighterType should be one of the values in FIGHTER_TYPE
// name should be supplied for human player or coach
def createLevel1Fighter = {
    num, fighterType, name = null ->
    
    def fighterName
    def isHuman
    def speed
    def strength
    def you                                   // Used in text descriptions of the fighter, i.e. "You hit..." or "Fighter 128 hits..."
    def you_lc                                // lowercase you i.e. "...hits you" or "..hits Fighter 128"
    def s                                     // For words pluralized with an "s" i.e. "hit" becomes "hits"
    def es                                    // For words pluralized with an "es" i.e. "punch" becomes "punches"
    def have                                  // i.e. "You have..." or "Fighter 128 has..."
    def unknownAttributes                     // list of attributes which should be shown to the user as "Unknown"
    
    if (name == null) {
        fighterName = "Fighter " + num       
    } else {
        fighterName = name
    }

    if (fighterType == FIGHTER_TYPE.human) {                            // some attributes are different for human player
        isHuman = true
        speed = PLAYER_SPEED
        strength = PLAYER_STRENGTH
        you = "You"
        you_lc = "you"
        s = ""
        es = ""
        have = "have"
        unknownAttributes = []
    } else {
        isHuman = false
        speed = generate_speed_or_strength()
        strength = generate_speed_or_strength()
        you = fighterName
        you_lc = fighterName
        s = "s"
        es = "es"
        have = "has"
        unknownAttributes = DEFAULT_UNKNOWN_ATTRIBUTES
    }

    return [num:            num,
            name:           fighterName,
            isHuman:        isHuman,
            you:            you,
            you_lc:         you_lc,
            s:              s,
            es:             es,
            have:           have,
            dopeLevel:      0,
            speed:          speed,
            strength:       strength,
            recupSkill:     0,
            attSkillArms:   0,
            attSkillLegs:   0,
            attSkillBody:   0,
            attSkillTarget: 0,
            defSkillArms:   0,
            defSkillLegs:   0,
            defSkillBody:   0,
            defSkillTarget: 0,
            health:         MAX_HEALTH,
            priority:       BASE_PRIORITY + speed,
            points:         0,
            unknown:        unknownAttributes]
}

// Saves fighter to the data registry
def save_fighter = {
    key, fighter ->
    fa_save(key + ".num", fighter.num)
    fa_save(key + ".name", fighter.name)
    fa_save(key + ".isHuman", fighter.isHuman)
    fa_save(key + ".you", fighter.you)
    fa_save(key + ".you_lc", fighter.you_lc)
    fa_save(key + ".s", fighter.s)
    fa_save(key + ".es", fighter.es)
    fa_save(key + ".have", fighter.have)
    fa_save(key + ".dopeLevel", fighter.dopeLevel)
    fa_save(key + ".speed", fighter.speed)
    fa_save(key + ".strength", fighter.strength)
    fa_save(key + ".recupSkill", fighter.recupSkill)
    fa_save(key + ".attSkillArms", fighter.attSkillArms)
    fa_save(key + ".attSkillLegs", fighter.attSkillLegs)
    fa_save(key + ".attSkillBody", fighter.attSkillBody)
    fa_save(key + ".attSkillTarget", fighter.attSkillTarget)
    fa_save(key + ".defSkillArms", fighter.defSkillArms)
    fa_save(key + ".defSkillLegs", fighter.defSkillLegs)
    fa_save(key + ".defSkillBody", fighter.defSkillBody)
    fa_save(key + ".defSkillTarget", fighter.defSkillTarget)
    def unknown_count = fighter.unknown.size()
    fa_save(key + ".unknown_count", unknown_count)
    for (def index = 0; index < unknown_count; index++) {
        fa_save(key + ".unknown" + index, fighter.unknown[index])
    }
}

// Pairs off the fighters in fightersList, makes them fight, and returns a list of the winners
def haveFights = {
    fightersList, fight_level ->
    def fighterA
    def fighterB
    def first = true
    def winnersList = []
    for (fighter in fightersList) {
        if (first) {
            fighterA = fighter
            first = false
        } else {
            fighterB = fighter
            first = true
            dope_opponent(fighterA, fighterB, fight_level)
            dope_opponent(fighterB, fighterA, fight_level)
            def fightResult = fight(fighterA, fighterB)
            def numTies = 0
            while (fightResult == "tie" && numTies < TIE_REMATCH_LIMIT) {     // If there were TIE_REMATCH_LIMIT ties in a row we declare fighterB the winner
                fightResult = fight(fighterA, fighterB)
                if (fightResult == "tie") {
                    numTies++
                }
            }
            fighterA.dopeLevel = 0
            fighterB.dopeLevel = 0
            if (fightResult == "fighterA") {
                winnersList += fighterA
            } else {
                winnersList += fighterB
            }
        }
    }
    return winnersList
}


// Creates an opponent for the indicated fighter at the indicated fightLevel
// Sets GLOBAL.fighter_left and GLOBAL.fighter_right indicating which respective side of the ring fighter and opponent will fight on
def createOpponent = {
    fighter, fightLevel ->
    // find first multiple of 2^fightLevel that is >= fighter.num  This will be called x
    int rangeSize = Math.pow(2, fightLevel - 1)
    int doubleRangeSize = rangeSize * 2
    int x = doubleRangeSize
    while (x < fighter.num) {
        x += doubleRangeSize
    }
    
    // Each fight is a pinnacle node in a tree
    // A fight at this particular fight level pits the winner of all the fighters in left branch of the tree against
    //   the winner of all the fighters in the right branch of the tree
    // We need to figure out whether our fighter fighter.num is the winner of the left branch or the right branch
    def leftRange = (x - doubleRangeSize + 1) .. (x - rangeSize)     // the numbers of the fighters in the left branch of the tree
    def rightRange = (x - rangeSize + 1) .. x                        // the numbers of the fighters in the right branch of the tree
    def range
    def branch
    if (fighter.num in leftRange) {
        range = rightRange           // if our fighter is in the left branch of the tree then opponent is the winner of the right branch
        branch = "right"
    } else {
        range = leftRange            // if our fighter is in the right branch of the tree then opponent is the winner of the left branch
        branch = "left"
    }
    def fighterList = []
    for (num in range) {                             // create a list of opponents at the bottom level of the branch
        fighterList += createLevel1Fighter(num, FIGHTER_TYPE.computer)
    }
    def level = 1
    while (fighterList.size() > 1) {                 // make the opponents fight each other until there is a final single victor
        fighterList = haveFights(fighterList, level)
        level++
    }
    assert level == fightLevel
    if (branch == "left") {
        GLOBAL.fighter_left = fighterList[0]
        GLOBAL.fighter_right = fighter
    } else {
        GLOBAL.fighter_left = fighter
        GLOBAL.fighter_right = fighterList[0]
    }
    save_fighter("fighter_left", GLOBAL.fighter_left)
    save_fighter("fighter_right", GLOBAL.fighter_right)
    return fighterList[0]
}

// Assumes one of GLOBAL.fighter_left and GLOBAL.fighter_right is controlled by the human player, the other by computer
// Returns a map where each key is a FIGHTER_TYPE value and each value is the corresponding player
// i.e. fighters = get_fighters();  fighters.human    fighters.computer
def get_fighters = {
    if (GLOBAL.fighter_left.isHuman) {
        return [(FIGHTER_TYPE.human):     GLOBAL.fighter_left,
                (FIGHTER_TYPE.computer):  GLOBAL.fighter_right]
    } else {
        return [(FIGHTER_TYPE.human):     GLOBAL.fighter_right,
                (FIGHTER_TYPE.computer):  GLOBAL.fighter_left]      
    }    
}


// Changes GLOBAL.current_tournament_status to either TOURNAMENT_STATUS.awaiting_fight_start or TOURNAMENT_STATUS.fight_when_ready,
// depending on whether the required time has elapsed since player either entered the tournament or completed their last fight
def fight_now_or_later = {
    int elapsed_time = getTime() - GLOBAL.countdown_start_time
    if (elapsed_time < PRE_FIGHT_WAITING_PERIOD) {
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.awaiting_fight_start
    } else {
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.fight_when_ready
    }
    fa_save("current_tournament_status", GLOBAL.current_tournament_status)
}


// Practice recuperating
def practice_recuperating = {
    human, coach ->
    show("I'm going to have to beat you up first so that you can practice recuperating.<br>" +
         "I'll let you know when I think you've had enough practice.")
    showButton("Start Recuperation Practice")
    coach.attSkillArms = 1000
    def startRecupSkill = human.recupSkill
    def startTime = getTime()                         // start the timer
    showStatus(human, coach, STAY_PUT, startTime)
    while ((human.recupSkill - startRecupSkill) < PRACTICE_THRESHOLD) {
        while (human.health > 0) {
            attack(coach, human, !ATTACKER_ON_LEFT, ATTACK_TYPE.arms)
            showStatus(human, coach, STAY_PUT, startTime)
        }
        attack(human, coach, ATTACKER_ON_LEFT, ATTACK_TYPE.rest)
        showStatus(human, coach, STAY_PUT, startTime)
    }
}

// Practice punching, kicking, or bodyslamming
def practice_attacking = {
    human, coach, type, skill, verb ->
    show("When you're ready, you can start " + verb.toLowerCase() + " me. I'll try to evade or block your blows, but<br>" +
         "because this is training, I'm not going to fight back.<br>" +
         "I'll let you know when I think you've had enough practice.")
    showButton("Start " + verb + " Practice")
    def startSkill = human[skill]
    def startTime = getTime()                         // start the timer
    showStatus(human, coach, STAY_PUT, startTime)
    while ((human[skill] - startSkill) < PRACTICE_THRESHOLD) {
        attack(human, coach, ATTACKER_ON_LEFT, type)
        coach.defSkillArms = 0
        coach.defSkillLegs = 0
        coach.defSkillBody = 0
        showStatus(human, coach, STAY_PUT, startTime)
    }
}


// Practice going for the target
def practice_going_for_target = {
    human, coach ->
    show("When you're ready, you can start trying to press the target button. I'll try to block you.<br>" +
         "I'll let you know when I think you've had enough practice.")
    showButton("Start Practicing Going For the Target")
    def startAttSkillTarget = human.attSkillTarget
    def startTime = getTime()                         // start the timer
    showStatus(human, coach, STAY_PUT, startTime)
    while ((human.attSkillTarget - startAttSkillTarget) < PRACTICE_THRESHOLD) {
        attack(human, coach, ATTACKER_ON_LEFT, ATTACK_TYPE.target)
        coach.defSkillTarget = 0
        showStatus(human, coach, STAY_PUT, startTime)
    }
}


// Practice defending against punching, kicking, or bodyslamming
def practice_defending = {
    human, coach, type, skill, verb ->
    show("When you're ready, I'll start " + verb.toLowerCase() + " you. Defend yourself as best you can.<br>" +
         "I'll let you know when I think you've had enough practice.")
    showButton("Start Practicing Defending Against " + verb)
    def startSkill = human[skill]
    def startTime = getTime()                         // start the timer
    showStatus(human, coach, STAY_PUT, startTime)
    while ((human[skill] - startSkill) < PRACTICE_THRESHOLD) {
        coach.attSkillArms = 0
        coach.attSkillLegs = 0
        coach.attSkillBody = 0
        attack(coach, human, !ATTACKER_ON_LEFT, type)
        showStatus(human, coach, STAY_PUT, startTime)
    }
}


// Practice defending target
def practice_defending_target = {
    human, coach ->
    show("When you're ready, I'll start attempting to press the target button. Try to stop me as best you can.<br>" +
         "I'll let you know when I think you've had enough practice.")
    showButton("Start Practicing Defending Target")
    def startDefSkillTarget = human.defSkillTarget
    def startTime = getTime()                         // start the timer
    showStatus(human, coach, STAY_PUT, startTime)
    while ((human.defSkillTarget - startDefSkillTarget) < PRACTICE_THRESHOLD) {
        coach.attSkillTarget = 0
        attack(coach, human, !ATTACKER_ON_LEFT, ATTACK_TYPE.target)
        showStatus(human, coach, STAY_PUT, startTime)
    }
}


// Lets the human player choose a skill to practice, and then lets them practice that skill against the coach
def practice_a_skill = {
    def fighters = get_fighters() 
    def human = fighters.human
    def coach = fighters.computer

    prepareFighterForFight(human)
    prepareFighterForFight(coach)
    GLOBAL.current_fight_length = 0

    def choicesList = ["Punching", "Kicking", "Bodyslamming", "Going for Target", "Recuperating", "Defending Against Punching", "Defending Against Kicking",
                       "Defending Against Bodyslamming", "Defending the Target"]
    def playerChoice = getSelectedValue("Practice session " + (GLOBAL.practice_sessions_completed + 1) + " of " + PRACTICE_SESSIONS + "<br>" +
                                        "What would you like to practice?", choicesList)

    view_fighter_attributes("Pre-Practice")

    switch(playerChoice) {
        case 0:
            practice_attacking(human, coach, ATTACK_TYPE.arms, "attSkillArms", choicesList[playerChoice])
            break
        case 1:
            practice_attacking(human, coach, ATTACK_TYPE.legs, "attSkillLegs", choicesList[playerChoice])
            break
        case 2:
            practice_attacking(human, coach, ATTACK_TYPE.body, "attSkillBody", choicesList[playerChoice])
            break
        case 3:
            practice_going_for_target(human, coach)
            break
        case 4:
            practice_recuperating(human, coach)
            break
        case 5:
            practice_defending(human, coach, ATTACK_TYPE.arms, "defSkillArms", "Punching")
            break
        case 6:
            practice_defending(human, coach, ATTACK_TYPE.legs, "defSkillLegs", "Kicking")
            break
        case 7:
            practice_defending(human, coach, ATTACK_TYPE.body, "defSkillBody", "Bodyslamming")
            break
        case 8:
            practice_defending_target(human, coach)
            break
    }

    show("Okay, that's enough. Very nicely done.")
    showButton("Continue")

    view_fighter_attributes("Post-Practice")

    GLOBAL.practice_sessions_completed++
    show("Saving practice info...")
    fa_save("practice_sessions_completed", GLOBAL.practice_sessions_completed)
    if (GLOBAL.practice_sessions_completed == PRACTICE_SESSIONS) {
        GLOBAL.practice_sessions_completed = 0
        fa_save("practice_sessions_completed", GLOBAL.practice_sessions_completed)
        def humanFighter = get_fighters().human
        changeFighterNum(humanFighter, rand(1, NUM_COMPETITORS))                    // Change the fighter number for the human fighter
        def opponent = createOpponent(humanFighter, GLOBAL.fight_level)             // Create a computer opponent for the human fighter
        fight_now_or_later()
    }
    show("Saving practice info......")
    save_fighter("fighter_left", GLOBAL.fighter_left)
    show("Saving practice info.........")
    save_fighter("fighter_right", GLOBAL.fighter_right)
}

// Allows the user to choose a different name for the coach. Returns the new name
// currentName is the current name of the coach
def getNewCoachName = {
    currentName ->
    def newName = ""
    setImage(FOLDER_NAME + GLOBAL.pics.coach)
    newName = getString("Hello, I'm " + currentName + ", your coach. What would you like my new name to be?", currentName)
    newName = newName.trim()
    while (newName == "") {
        newName = getString("You have to give me a name! What would you like my new name to be?", currentName)
        newName = newName.trim()
    }
    show("My name is now " + newName + ". Cool beans!")
    showButton("Okay")
    return newName
}


// Prompts the user to choose a new picture for the coach and saves that picture to the images folder (unless operation was cancelled)
def changeCoachPicture = {
    def userWantsToChangePic        // A Boolean which is true if the user wants to change the coach's picture
    setImage(FOLDER_NAME + GLOBAL.pics.coach)
    userWantsToChangePic = getBoolean("This is your coach.", "Change picture", "Done")
    while (userWantsToChangePic) {
        def filePath = getFile("Select a picture for your coach")
        if (filePath != null) {
            filePath = filePath.toLowerCase()
            if (filePath.endsWith(".jpg") || filePath.endsWith(".jpeg") || filePath.endsWith(".png")) {
                def extension
                if (filePath.endsWith("jpg")) {
                    extension = ".jpg"
                } else {
                    extension = ".png"
                }
                def fileName = "coach" + getTime() + extension      // getTime() is included due to a bug in setImage
                new File("images/" + FOLDER_NAME + fileName).delete()
                new File("images/" + FOLDER_NAME + fileName) << new File(filePath).getBytes()
                GLOBAL.pics.coach = fileName
                fa_save("pics.coach", GLOBAL.pics.coach)
            } else {
                show("Invalid file extension. Must be JPG, JPEG, or PNG")
                showButton("Acknowledged")
            }
        } else {
            show("No picture selected.")
            showButton("Acknowledged")            
        } 
        setImage(FOLDER_NAME + GLOBAL.pics.coach)
        userWantsToChangePic = getBoolean("This is your coach.", "Change picture", "Done")
    }
}

// Prompts the user to choose a new picture for fighter of level indicated and saves that picture to the images folder (unless operation was cancelled)
def changeFighterPicture = {
    level ->
    def userWantsToChangePic        // A Boolean which is true if the user wants to change the coach's picture
    setImage(FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)])
    userWantsToChangePic = getBoolean("This is the picture displayed when fighting at Level " + level, "Change picture", "Done")
    while (userWantsToChangePic) {
        def filePath = getFile("Select a picture for Level "+ level + " fighter")
        if (filePath != null) {
            filePath = filePath.toLowerCase()
            if (filePath.endsWith(".jpg") || filePath.endsWith(".jpeg") || filePath.endsWith(".png")) {
                def extension
                if (filePath.endsWith("jpg")) {
                    extension = ".jpg"
                } else {
                    extension = ".png"
                }
                def fileName = FIGHTER_LEVEL_KEYSTRING + levelString(level) + getTime() + extension   // getTime() is included due to a bug in setImage
                new File("images/" + FOLDER_NAME + fileName).delete()
                new File("images/" + FOLDER_NAME + fileName) << new File(filePath).getBytes()
                GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)] = fileName
                fa_save("pics." + FIGHTER_LEVEL_KEYSTRING + levelString(level), GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)])
            } else {
                show("Invalid file extension. Must be JPG, JPEG, or PNG")
                showButton("Acknowledged")
            }
        } else {
            show("No picture selected.")
            showButton("Acknowledged")            
        } 
        setImage(FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)])
        userWantsToChangePic = getBoolean("This is the picture displayed when fighting at Level " + level, "Change picture", "Done")
    }
}

// Changes the coach's name
def changeCoachName = {
    changeFighterName(GLOBAL.coach, getNewCoachName(GLOBAL.coach.name))
    show("Saving coach name...")
    save_fighter("coach", GLOBAL.coach)
    show("Saving coach name......")
    save_fighter("fighter_left", GLOBAL.fighter_left)
    show("Saving coach name.........")
    save_fighter("fighter_right", GLOBAL.fighter_right)
}


// Allows the user to change the pictures used for the coach and fighters
def changePictures = {
    def actionList = []
    actionList +=       [label: "Coach",                   action: changeCoachPicture ]
    for (i in 1..NUM_FIGHT_LEVELS) {
        actionList +=   [label: "Level " + i + " Fighter", action: changeFighterPicture, args: i ]
    }
    actionList +=      [label: "Done",                     action: { } ]

    menu({ actionList }, { FOLDER_NAME + "title_screen.png" }, { "Which picture would you like to change?" } ) 
}


// Displays info about tournaments and fights
def tournament_info = {
    def tournaments = "In a tournament at the Sexopolis Fight Arena, " + NUM_COMPETITORS + " competitors vie for supremacy in single-elimination fight bouts. " +
                      "There are therefore " + NUM_FIGHT_LEVELS + " fights you must win in order to win the tournament, because each level of fighting will " +
                      "eliminate half of the remaining contestants. For example, after the Level 1 fights, " + (NUM_COMPETITORS / 2) +
                      " contestants will remain.<br><br>" +
                      "Fighters must remain chaste (no masturbating) during the tournament. Once entering the tournament, the fighter must wait at least 24 hours " +
                      "before engaging in the Level 1 fight. That time can be used for up to " + PRACTICE_SESSIONS + " practice sessions. After each successfully" +
                      " won fight, there is another 24-hour minimum waiting period before the next level fight can be fought."
    def fights = "Each fight takes place in a fighting ring with one competitor on the left side of the ring and the other competitor on the right side " +  
                 "of the ring. During the fight you can try to attack your opponent by either punching, kicking, or bodyslamming. If your opponent is unable " +
                 "to evade or block your attack, they will be temporarily stunned and tired. Depending on how powerful your blow was, they may not be able to " +
                 "retaliate for a few moments. If you yourself have received damaging blows, you may wish to rest to try recuperating your energy.<br><br>" +
                 "Another option you have during a fight is to attempt scoring a point. The first fighter to score " + POINTS_TO_WIN + " points will be declared " +
                 "the fight victor. You attempt to score a point by pressing a target button on your opponent's side of the ring. When you press the target button," +
                 " there is a " +
                 "1 in " + TARGET_ACT_CHANCE + " chance that a point will be scored (determined randomly by the computer).<br><br>" +
                 "As a fight proceeds, a countdown timer is displayed. The fight ends either when one of the competitors reaches " + POINTS_TO_WIN + " points or " +
                 timeString(FIGHT_LENGTH) + " minutes have elapsed. In the latter case, the fighter with the most points is the winner. However, if both fighters " +
                 "have the same number of points, the fight will be declared a tie. After a minimum 24-hour waiting period, the fighters engage in a re-match. " +
                 "If it happens that there are " + TIE_REMATCH_LIMIT + " ties in a row, then the fighter who was assigned to the right side of the ring will be the " +
                 "declared victor to move on to the next level."
    def attributes1 = "As a fighter, you have various attributes. Two innate attributes, which you cannot improve upon during the course of the tournament, " +
                    "are speed (ranging in value from " + MIN_SPEED + " to " + MAX_SPEED + ") and strength " +
                    "(ranging in value from " + MIN_STRENGTH + " to " + MAX_STRENGTH + "). By the looks of it, your speed is " + PLAYER_SPEED + 
                    " and your strength is " + PLAYER_STRENGTH + ".<br><br>" +
                    "Speed determines how quickly and often you will be able to act against your opponent before they " +
                    "act against you. For example, you will find it easy to make moves against an opponent with a speed of " + (MIN_SPEED + 2) + " while you might " +
                    "find yourself with little opportunity to attack an opponent with a speed of " + (MAX_SPEED - 2) + ". " +
                    "Your strength determines by how much your opponent's energy is dampened when you land a blow against them."
    def attributes2 = "The remaining attributes are all skills which will start at 0 " +
                    "but which will improve as you practice and engage in fights. The skill attributes have no upper limit. " +
                    "One of your skills is your ability to recuperate. Each time you have a surge of energy while resting, you will be better able to " +
                    "recuperate your energy the next time you rest.<br><br>" +
                    "You also have four different attack skills: your ability to punch, to kick, to bodyslam, and to press your opponent's target button. Each time " +
                    "you make a successful attack of a particular type, you will be better able to carry out that type of atttack the next time. Your skill " +
                    "for the target is based on pressing the button, whether or not a point is scored.<br><br>" +
                    "There are also four corresponding defense skills: your ability to defend against kicks, punches, bodyslams, and against opponents' attempts " +
                    "to press your own target button. You gain skill in each type of defense when you successfully defend against an opponent's attack of that type. " +
                    "Of course, it logically follows that if you are skilled, at let's say, punching, and your opponent is skilled at defending against punching, " +
                    "you will have about a 50/50 chance of your punch landing. On the other hand, if you are skilled at kicking and your opponent has little " +
                    "experience at defending against kicks, you will have a high chance of landing your blow. Or, if you are not very skilled at bodyslamming " +
                    "and your opponent has honed their skill at defending against bodyslamming, you will find that your opponent is easily able to block or " +
                    "evade your bodyslam."
    def favors = "Another aspect of tournaments at the Sexopolis Fight Arena is what happens after you win or lose a fight. The rules of the tournament specify " +
                 "that the victor of the fight will be able to demand as many favors from the defeated fighter as the level number. So, after a Level 1 fight, " +
                 "the winner will be able to demand one favor from the loser. After a Level 5 fight, the winner will be able to demand 5 favors.<br><br>" +
                 "When you win a fight, I would suggest that you make strategic use of your favors; try to find out as much information as you can about your next " +
                 "opponent to help give yourself an advantage during the upcoming fight.<br><br>" +
                 "I must also tell you about doping opponents. While doping an opponent is of course not allowed by tournament rules, illegal doping is rampant, " +
                 "so as your coach, I must warn you that you may find yourself doped. I will also suggest, if a defeated opponent has dope available to " +
                 "give you, demand they give it to you as one of their favors. Another favor you might demand is to dope your next opponent with the dope you have " +
                 "acquired. The type of dope that is circulating are speed dope capsules. Each capsule administered to a fighter's drinking water before a " +
                 "fight will decrease their speed during the fight by 1. The effect of capsule dosages is cumulative, so if you administered, say 3 " +
                 "capsules to an opponent before a fight, their speed for that fight would be reduced by 3."
    def strategies1 = "As you have average speed and strength, you will find it quite difficult to win a tournament, so I would like to give you a few strategy " +
                     "tips for winning fights and the tournament. It should be obvious that, during a fight, you should try to score points by going for the " +
                     "points target.<br><br>However, unlike other forms of attack, in addition to the attacker's target attack skill and the defender's skill at " +
                     "defending against target attacks, successfully pressing the target button also depends on the relative energy levels of the attacker and " +
                     "the defender. The attack is more likely to be successful if the attacker's energy level is high and the defender's energy level is low.<br><br>" +
                     "So, as an attacker, you should try to get a few good hits in onto your opponent, then go for the target while their energy is low. As a " +
                     "defender, if you find that your energy is low, you should rest and try to recuperate before your opponent tries to go for your own " +
                     "target."
    def strategies2 = "When you fight, you'll want to think about not just how to win the current fight, but how to win future fights as well. " +
                      "During your very first fight, neither you nor your opponent will have very much experience. So let's say you have 0 skill at " +
                      "punching and your opponent has 0 skill at defending against punches. Now you try to punch your " +
                      "opponent and miss. Your miss means that your opponent has improved their skill at defending against punches, making their defense skill " +
                      "higher relative to your attack skill. If you miss your first 3 or 4 punches, you will have very little chance of punching this opponent " +
                      "successfully after that. So switch to either kicking or bodyslamming. Once you find a successful method of attack, it's best to stick " +
                      "to that one method and hone it throughout the rest of the tournament."
    def strategies3 = "Besides determining which fighting mode to specialize in, there's another strategy to utilize during the early levels of fighting. " +
                      "The biggest determinant of which fighter will win a fight are the relative speeds of the two fighters.<br><br>" +
                      "Because fighters are matched up randomly, during the early levels your opponents may be slower than you, about the same speed, or faster. " +
                      "If you are unfortunate enough to be paired up against a faster fighter, there's not much you can do about it other than go for the points " +
                      "target as quickly and often as you can.<br><br>However, if you are paired up against a slower fighter or fighter of similar speed, score 2 " +
                      " points " +
                      "quickly but hold back going for the 3rd point while your opponent is still at 1 or 0 points. Use the four minute fight time to build up " +
                      "your specialized attack skill, or let the opponent attempt to make attacks against you. If they miss, you build up one of your defense " +
                      "skills. If they successfully lower your energy level by a substantial amount, then use that opportunity to try to improve your " +
                      "recuperation skill. Improving these skills will help you in future fights. Only go for the points target if it becomes a 2-2 score."
    def strategies4 = "After the early levels of fighting, the slower fighters will likely have been eliminated. At this point, you will probably want to start " +
                      "using the favors you earn to find out how fast each successive opponent is and doping the fast ones. I wouldn't waste your dope on speed " +
                      "level 6 or 7 fighters. Save it for the 8s, 9s, and 10s.<br><br>" +
                      "In the end, all of these strategy suggestions are just that, suggestions. Try different things and develop your own strategies as you see fit."
    def lastnote =    "One last note. As I've said, winning a tournament will be very difficult, and you will most likely lose your first one. Don't despair, your " +
                      "skills are retained between tournaments. Tournament rules say that only inexperienced fighters are allowed in a tournament, but I can be " +
                      "be bribed :)<br><br>" +
                      "Good luck!"
    def messageScreenList = [["Tournaments", tournaments],    // heading and body text for each message screen 
                             ["Fights", fights],
                             ["Fighter Attributes", attributes1],
                             ["Fighter Attributes, continued", attributes2],
                             ["Favors", favors],
                             ["Strategies, page 1 of 4", strategies1],
                             ["Strategies, page 2 of 4", strategies2],
                             ["Strategies, page 3 of 4", strategies3],
                             ["Strategies, page 4 of 4", strategies4],
                             ["A Final Note", lastnote]]
    setImage(FOLDER_NAME + GLOBAL.pics.coach)                             
    for (screen in messageScreenList) {
        show("<h2>" + screen[0] + "</h2><p>" + screen[1] + "</p>")
        showButton("Continue")
    }
}

// Displays some charts which might help player to strategize
def bonus_info = {

    def message_speed_and_doping =  "A fighter of strength 5 and no skills was entered into a tournament repeatedly. Experience was retained between fights " +
                                    "but not between tournaments. The chart shows the average highest fight level the fighter could achieve in the tournaments at " +
                                    "different speed abilities, for tournaments where doping was allowed to happen and where it wasn't.<br><br>" +
                                    "Notice how speed is a strong determinant of how far a fighter will get in a tournament. Also notice that with doping " +
                                    "rampant in tournaments (as it is for the tournaments you are participating in), fighters with speeds up to 7 do better " +
                                    "while fighters with speeds of 8 or more do worse relative to how they would do if no doping occurred. So doping in " +
                                    "tournaments helps an average-speed fighter like yourself!"
    def message_practice = "A fighter of speed 5 and strength 5, with practice in a single skill (skill of 9), was entered into a tournament repeatedly. " +
                           "Experience was retained " +
                           "between fights but not between tournaments. The chart shows " +
                           "the average highest fight level the fighter could achieve for each skill that was practiced. A 'no practice (all skills 0)' " +
                           "item is included for comparison.<br><br>" +
                           "Notice how practice in <em>any</em> skill will help a fighter do better in a tournament, but some skills provide a better advantage " +
                           "than others. Skill at recuperating seems to be slightly more useful than most, but it is skill at defending the target that has " +
                           "the most impact. The chart doesn't show skill practice combinations, but it would seem that at the very least you should dedicate " +
                           "at least one practice session to defending the target."
    def message_experience = "A fighter of speed 5 and strength 5 was allowed varying amounts of defense experience and entered into a tournament repeatedly. " +
                             "Experience was retained between fights but not between tournaments. The chart shows the average highest fight level the fighter could " +
                             "achieve for the different amounts of defense experience (defending against punches, kicking, bodyslamming, and the target).<br><br> " +
                             "Since the tournament rules don't allow it, no other fighters in a tournament will have any experience. So, by allowing you into a " +
                             "tournament with experience, you can see from the chart that you will have a tremendous advantage over inexperienced fighters."
    def messageScreenList = [[message_speed_and_doping, "chart_speed_and_doping.png"],    // message and chart file for each bonus information screen 
                             [message_practice, "chart_practice.png"],
                             [message_experience, "chart_experience.png"]]

    for (screen in messageScreenList) {
        setImage(FOLDER_NAME + screen[1])
        show(screen[0])
        showButton("Continue")
    }
}


// Lets the user choose which punishments will be permitted during game play by presenting checkboxes   
def changePunishmentsPermitted = {

    def playerChoice = 0
    def choiceList = ["Change Punishments Permitted", "Done"]
    while (playerChoice != choiceList.size()-1) {   // loop while the user hasn't chosen "Done"
        def checkboxLabelsList = []                 // the labels to display on the check boxes
        def checkboxValuesList = []                 // the values of the check boxes
        def checkboxValuesMap = [:]                 // associates punishment type keys with indexes in the check box values list
        def index = 0
        def message = "<p>During game play, there may be occasions where other fighters or your coach may punish you. " +
                    "Here you can choose which types of punishment you feel comfortable with. " +
                    "You must choose at least one form of punishment. These are the punishments currently allowed:</p><ul>"
 
        for (punishment_type in GLOBAL.punishments_permitted) {    // Loop through the map of punishment types
            checkboxLabelsList += punishment_type.value.label      // put the punishment type label into the list of check box labels
            if (punishment_type.value.permitted) {
                message += "<li>" + punishment_type.value.label + "</li>" // tell the user that this punishment type is allowed
            }
            checkboxValuesList[index] = punishment_type.value.permitted    // put the punishment type permission value into the list of check box values
            checkboxValuesMap[punishment_type.key] = index                 // Associates a punishment type key with an index in the check box values list
            index++
        }  
        message += "</ul>"
        playerChoice = getSelectedValue(message, choiceList)
        if (playerChoice == 0) {
            def countTrue = 0
            while ((countTrue == 0) && (checkboxValuesList != null)) {     // Loop until we get a list of values where at least one value is true
                checkboxValuesList = getBooleans("Choose punishments permitted:", checkboxLabelsList, checkboxValuesList)
                if (checkboxValuesList != null) {                          // checkboxValuesList will be null if the user canceled or closed the dialog box
                    for (value in checkboxValuesList) {                    // Count the number of check boxes that were checked
                        if (value) {
                            countTrue++
                        }
                    }
                    if (countTrue > 0) {                                   // Only change the punishment type settings if at least one check box was checked
                        for (punishment_type in GLOBAL.punishments_permitted) {
                            punishment_type.value.permitted = checkboxValuesList[checkboxValuesMap[punishment_type.key]]
                            fa_save("punishment_type." + punishment_type.key, punishment_type.value.permitted)
                        }                          
                    }
                }                    
            }
        }              
    }
}

// Complete a punishment session for the supplied number of units. Show designated image
def punishment = {
    units, imageFile ->
    setImage(imageFile)
    show("Get naked.")
    showButton("I'm naked.")
    
    // Decide on main punishment type, implement, and variety.
    def punishmentChoices = [:]
    def keyList = []
    for (punishment_type in GLOBAL.punishments_permitted) {    // Loop through the map of punishment types
        if (punishment_type.value.permitted) {
            punishmentChoices[punishment_type.key] = punishment_type.value.label
            keyList += punishment_type.key
        }
    }  
    def choice = keyList[rand(0, keyList.size()-1)]
    def implementList = []
    def implement
    def strike1
    def strike2
    def hard_slap =    [label: "a hard slap",        action: { playSound(FOLDER_NAME + "spank1.mp3"); wait(2) } ]
    def five_slaps =   [label: "five quick slaps",   action: { playSound(FOLDER_NAME + "spank5.mp3"); wait(3) } ]
    def flick =        [label: "a flick",            action: { playSound(FOLDER_NAME + "flick1.mp3"); wait(1) } ]
    def three_flicks = [label: "three quick flicks", action: { playSound(FOLDER_NAME + "flick3.mp3"); wait(2) } ]
    def strikeList
    def message
    switch (choice) {
        case "ballbusting":
            implementList += "your hand"
            if (loadBoolean("toys.crop")) {
                implementList += "a crop or similar implement"
            }
            implement = implementList[rand(0, implementList.size()-1)]
            strikeList = [hard_slap, five_slaps, flick, three_flicks]
            strike1 = strikeList[rand(0, strikeList.size()-1)]
            strikeList -= strike1
            strike2 = strikeList[rand(0, strikeList.size()-1)]
            message = "Using " + implement + ", in sync with the sounds, you are going to give yourself " + strike1.label + " on the balls followed by " +
                      strike2.label + "."
            break
        case "nipple_torture":
            implementList += ""
            if (loadBoolean("toys.nipple_clamps")) {
                implementList += "Affix a nipple clamp to each of your nipples."
            }
            if (loadBoolean("toys.clothespins")) {
                implementList += "Affix a clothespin to each of your nipples."
            }
            implement = implementList[rand(0, implementList.size()-1)]
            strikeList = [flick, three_flicks]
            strike1 = strikeList[rand(0, strikeList.size()-1)]
            strikeList -= strike1            
            strike2 = strikeList[rand(0, strikeList.size()-1)]
            message = implement + " In sync with the sounds, you are going to give yourself " + strike1.label + " on the nipples followed by " +
                      strike2.label + ", alternating nipples as instructed."        
            break
        case "spanking":
            implementList += "your hand"
            if (loadBoolean("toys.crop")) {
                implementList += "a crop or similar implement"
            }
            if (loadBoolean("toys.paddle")) {
                implementList += "a paddle or similar implement"
            }
            implement = implementList[rand(0, implementList.size()-1)]
            strikeList = [hard_slap, five_slaps]
            strike1 = strikeList[rand(0, strikeList.size()-1)]
            strikeList -= strike1            
            strike2 = strikeList[rand(0, strikeList.size()-1)]
            message = "Using " + implement + ", in sync with the sounds, you are going to give yourself " + strike1.label + " on the butt followed by " +
                      strike2.label + ", alternating cheeks as instructed."
            break
    }
        
    // Carry out the punishment
    show(message + " This will be done " + units + " times. There will be a short delay after you're ready before the sounds begin.")
    showButton("Ready")
    wait(4)
    for (def i=1; i<=units; i++) {
        if (choice == "nipple_torture" || choice == "spanking") {
            show("<h1>Round " + i + ", left</h1>")
        } else {
            show("<h1>Round " + i + "</h1>")
        }
        strike1.action()
        strike2.action()
        if (choice == "nipple_torture" || choice == "spanking") {
            show("<h1>Round " + i + ", right</h1>")
            strike1.action()
            strike2.action()            
        }
    }
    if (choice == "nipple_torture" && implement != "") {
        show("You may remove the items from your nipples.")
        showButton("Removed")
    }
    show("That concludes your punishment.")
    showButton("Done")
}


// Given an attribute key such as "recupSkill", returns user-friendly text describing that attribute
def get_attribute_text = {
    attribute_key ->
    for (group in ATTRIBUTES_TO_DISPLAY) {
        if (attribute_key in group) {
            return group[attribute_key]
        }
    }
}

// Presents confirmation screen, then enters player into tournament if confirmed
// supplemental_text is text that will be added to the confirmation message
// supplemental_action is additional code that will be executed if entering the tournament is confirmed
def enter_tournament_confirmation = {
    supplemental_text = "", supplemental_action = {} ->
    def confirmed = getBoolean("Remember, you must remain chaste during the tournament. " +
                                "That means no masturbating for what could be ten days or more if you do well. " +
                                "And if you don't do so well...you might find yourself being punished!<br><br>" + supplemental_text + "<br><br>" +
                                "Are you sure you want to enter the tournament now?")
    if (confirmed) {
        supplemental_action()
        GLOBAL.tournament_num++
        fa_save("tournament_num", GLOBAL.tournament_num)
        GLOBAL.num_competitors_remaining = NUM_COMPETITORS 
        fa_save("num_competitors_remaining", GLOBAL.num_competitors_remaining)
        GLOBAL.fight_level = 1 
        fa_save("fight_level", GLOBAL.fight_level)
        GLOBAL.fight_levels_completed = 0  
        fa_save("fight_levels_completed", GLOBAL.fight_levels_completed)
        GLOBAL.num_ties = 0
        fa_save("num_ties", GLOBAL.num_ties)
        GLOBAL.countdown_start_time = getTime()
        fa_save("countdown_start_time", GLOBAL.countdown_start_time)
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.practicing
    } else {
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.not_in
    }
    fa_save("current_tournament_status", GLOBAL.current_tournament_status)
}

// After giving user a chance to confirm, resets all human player's fighting skills to 0 and dope inventory to 0; enters them in tournament
def enter_tournament_reset_skills = {
    def message = "Additionally, all of your fighting skills will be reset to 0 and you will lose any dope in your possession."
    def actions = {
        def fighter = get_fighters().human
        for (skill in SKILL_LIST) {
            fighter[skill] = 0
        }
        GLOBAL.dope_inventory = 0
        show("Saving fighter info...")
        fa_save("dope_inventory", GLOBAL.dope_inventory)
        save_fighter("fighter_left", GLOBAL.fighter_left)
        show("Saving fighter info......")
        save_fighter("fighter_right", GLOBAL.fighter_right)
    }
    enter_tournament_confirmation(message, actions)
}

// After giving user a chance to confirm, resets human player's best fighting skill to 0 and dope inventory to 0, lets coach punish them, and enters them in tournament
def enter_tournament_punish = {
    best_skill ->
    def message = "Additionally, your " + get_attribute_text(best_skill).toLowerCase() + " will be reset to 0, you will lose any dope in your possession, and I "
    message += "will punish you."
    def actions = {
        def fighter = get_fighters().human
        fighter[best_skill] = 0
        GLOBAL.dope_inventory = 0
        fa_save("dope_inventory", GLOBAL.dope_inventory)
        punishment(PUNISHMENT_UNITS * (GLOBAL.tournaments_won + GLOBAL.tournaments_lost), FOLDER_NAME + GLOBAL.pics.coach)
        show("Saving fighter info...")
        save_fighter("fighter_left", GLOBAL.fighter_left)
        show("Saving fighter info......")
        save_fighter("fighter_right", GLOBAL.fighter_right)        
    }
    enter_tournament_confirmation(message, actions)
}

// Returns the human fighter's best skill
def determine_best_skill = {
    def highest_value = 0
    def best_skill = ""
    def fighter = get_fighters().human
    for (skill in SKILL_LIST) {
        if (fighter[skill] >= highest_value) {
            best_skill = skill
            highest_value = fighter[skill]
        }
    }
    return best_skill
}

// Confirms that the user wants to enter a tournament and enters them if they confirm
def enter_tournament = {
    
    if ((GLOBAL.tournaments_won + GLOBAL.tournaments_lost) > 0) {
        def actionList = [[label: "Wipe out my skills and let me enter tournament",  action: enter_tournament_reset_skills ],
                          [label: "Punish me and let me enter tournament",           action: enter_tournament_punish, args: determine_best_skill() ],
                          [label: "Not Now",                                         action: { } ]] 
       
        def get_message = {
            def dopeInvMessage
            if (GLOBAL.dope_inventory > 0) {
                dopeInvMessage = "you give me all of the dope currently in your possession, "
            } else {
                dopeInvMessage = ""
            }
            def message = ""
            def tournament_text = ""
            if ((GLOBAL.tournaments_won + GLOBAL.tournaments_lost) == 1) {
                tournament_text = "a tournament"
            } else {
                tournament_text = "multiple tournaments"
            }
            message += "The Sexopolis Fight Arena tournament rules specify that only inexperienced fighters may participate in a tournament. "
            message += "As you've already participated in " + tournament_text + ", you have fight experience and therefore do not qualify to participate "
            message += "in another tournament.<br><br>"
            message += "However, as your coach I'm willing to pull a few strings for you and can let you into a tournament. In exchange you must be willing "
            message += "to do something for me. Here are your options:<br><br>"
            message += "<ol>"
            message += "<li>I'll administer a drug which will wipe out all of your fighting skills (reset them to 0), " + dopeInvMessage
            message += "and you enter the tournament.</li>"
            message += "<li>I'll administer a drug which will wipe out only your "
            message += get_attribute_text(determine_best_skill()).toLowerCase() + ", " + dopeInvMessage + "I get to punish you, and you enter the tournament.</li>"
            message += "<li>You do not enter a tournament at this time.</li></ol>"
            return message
        }

        menu( { actionList }, { FOLDER_NAME + GLOBAL.pics.coach }, get_message, !STAY_PUT )
        
    } else {
        enter_tournament_confirmation()
    }

}


// User enters the fight ring and engages in a fight
def fight_ring = {
    setImage(FOLDER_NAME + "fight_ring.png")
    def fighters = get_fighters()
    dope_opponent(fighters.computer, fighters.human, GLOBAL.fight_level)                       // possibly dope the human player
    if (fighters.human.dopeLevel > 0) {                                                        // inform the human player if he/she was indeed doped
        show("You feel slower than usual&mdash;you've been doped!")
        showButton("Darn!")
    }
    view_fighter_attributes("Pre-Fight")
    show("<p style=\"text-align:center\">---------------------------------------------</p>" +
         "<h1 style=\"text-align:center\">LEVEL " + GLOBAL.fight_level + "</h1>" +
         "<p style=\"text-align:center\">---------------------------------------------</p>")
    showButton("Enter the Ring")
    GLOBAL.current_tournament_status = TOURNAMENT_STATUS.fight_started
    fa_save("current_tournament_status", GLOBAL.current_tournament_status)
    def fightResult = fight(GLOBAL.fighter_left, GLOBAL.fighter_right, GLOBAL.fight_level)     // carry out the fight
    show("Saving fight results...")
    save_fighter("fighter_left", GLOBAL.fighter_left)
    show("Saving fight results......")
    save_fighter("fighter_right", GLOBAL.fighter_right)
    show("Saving fight results.........")
    GLOBAL.countdown_start_time = getTime()
    fa_save("countdown_start_time", GLOBAL.countdown_start_time)
    if (fightResult == "tie") {                                                               // fight resulted in a tie
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.awaiting_fight_start
        fa_save("current_tournament_status", GLOBAL.current_tournament_status)
        GLOBAL.num_ties++
        fa_save("num_ties", GLOBAL.num_ties)
        if (GLOBAL.num_ties == TIE_REMATCH_LIMIT) {
            show(TIE_REMATCH_LIMIT + " ties in a row; " + GLOBAL.fighter_right.name + ", as the fighter on the right side of the ring, is declared victor!")
            showButton("Acknowledged")
            fightResult = "fighterB"
        }
    }
    if ((GLOBAL.fighter_left.isHuman && fightResult == "fighterA") || (GLOBAL.fighter_right.isHuman && fightResult == "fighterB")) {   // the human won
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.fight_won_get_favors
        fa_save("current_tournament_status", GLOBAL.current_tournament_status)
        GLOBAL.fight_levels_completed = GLOBAL.fight_level
        fa_save("fight_levels_completed", GLOBAL.fight_levels_completed)
        GLOBAL.fight_level++
        fa_save("fight_level", GLOBAL.fight_level)
        GLOBAL.num_ties = 0
        fa_save("num_ties", GLOBAL.num_ties)
        GLOBAL.num_competitors_remaining /= 2
        fa_save("num_competitors_remaining", GLOBAL.num_competitors_remaining)
    } else {
        if ((GLOBAL.fighter_left.isHuman && fightResult == "fighterB") || (GLOBAL.fighter_right.isHuman && fightResult == "fighterA")) {   // the human lost
            GLOBAL.current_tournament_status = TOURNAMENT_STATUS.fight_lost_do_favors
            fa_save("current_tournament_status", GLOBAL.current_tournament_status)
            GLOBAL.tournaments_lost++
            fa_save("tournaments_lost", GLOBAL.tournaments_lost)
        }
    }
    if (fightResult != "tie") {
        GLOBAL.fighter_left.unknown = []     // let the user see the opponent's fighter attributes
        fa_save("fighter_left.unknown_count", 0)
        GLOBAL.fighter_right.unknown = []
        fa_save("fighter_right.unknown_count", 0)
        GLOBAL.favors_completed = 0
        fa_save("favors_completed", GLOBAL.favors_completed)
    }
    view_fighter_attributes("Post-Fight")
    GLOBAL.fighter_left.dopeLevel = 0
    fa_save("fighter_left.dopeLevel", GLOBAL.fighter_left.dopeLevel)
    GLOBAL.fighter_right.dopeLevel = 0
    fa_save("fighter_right.dopeLevel", GLOBAL.fighter_right.dopeLevel)
    if (GLOBAL.current_tournament_status == TOURNAMENT_STATUS.fight_won_get_favors) {                    // if the fight was won
        if (GLOBAL.fight_levels_completed == NUM_FIGHT_LEVELS) {                                         // if the tournament was won
            GLOBAL.tournaments_won++
            fa_save("tournaments_won", GLOBAL.tournaments_won)
            playBackgroundSound(FOLDER_NAME + "won_tournament.mp3")
            show("<h1 style=\"text-align:center\">******************************************************<br>" + 
                 "" + fighters.human.name + " (" + loadString("intro.name") + ") has won the tournament!<br>" +
                 "******************************************************</h1>")
            showButton("Hurray!")
        } else {
            def opponent = createOpponent(fighters.human, GLOBAL.fight_level) // Create a new computer opponent for the human fighter
        }
    }
    if (GLOBAL.current_tournament_status == TOURNAMENT_STATUS.fight_lost_do_favors && GLOBAL.fight_level < NUM_FIGHT_LEVELS) {
        def opponent = createOpponent(fighters.human, GLOBAL.fight_level + 1) // Create a new computer opponent for favor information gathering and dope-giving
    }    
}


// Forfeit a fight
def forfeit = {
    GLOBAL.tournaments_lost++
    fa_save("tournaments_lost", GLOBAL.tournaments_lost)
    GLOBAL.current_tournament_status = TOURNAMENT_STATUS.fight_lost_do_favors
    fa_save("current_tournament_status", GLOBAL.current_tournament_status)
    GLOBAL.countdown_start_time = getTime()
    fa_save("countdown_start_time", GLOBAL.countdown_start_time)
    GLOBAL.favors_completed = 0
    fa_save("favors_completed", GLOBAL.favors_completed)
    GLOBAL.fighter_left.dopeLevel = 0
    fa_save("fighter_left.dopeLevel", GLOBAL.fighter_left.dopeLevel)
    GLOBAL.fighter_right.dopeLevel = 0
    fa_save("fighter_right.dopeLevel", GLOBAL.fighter_right.dopeLevel)
    if (GLOBAL.current_tournament_status == TOURNAMENT_STATUS.fight_lost_do_favors && GLOBAL.fight_level < NUM_FIGHT_LEVELS) {
        def opponent = createOpponent(get_fighters().human, GLOBAL.fight_level + 1) // Create a new computer opponent for favor information gathering and dope-giving
    }        
}

// Saves favor choices to the data registry
def save_favor_choices = {
    fa_save("favor_choices_count", GLOBAL.favor_choices.size())
    for(def index = 0; index < GLOBAL.favor_choices.size(); index++) {
        fa_save("favor_choice" + index, GLOBAL.favor_choices[index])
    }    
}

// Human player must perform a favor for the fight winner
def perform_favor = {
    setImage(FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(GLOBAL.fight_level)])
    def message = ""
    if (GLOBAL.fight_level == NUM_FIGHT_LEVELS) {   // if the final fight level, opponent won the tournament
        message += "Well, isn't this exciting? It was down to just the two of us out of " + NUM_COMPETITORS + " competitors. "
        message += "And now I've won the final fight, and you have lost. That's right&mdash;you're a fucking <em><b>LOSER</b></em>.<br><br>"
        message += "How does it feel, to have come all this way, only to lose in the end? Furthermore, now you owe me favors, "
        message += NUM_FIGHT_LEVELS + " of them in fact. Because I'm the tournament winner (ha, ha, you pathetic <em><b>LOSER</b></em>!), I don't need to worry "
        message += "about scheming against my next opponent&mdash;there are no more opponents to worry about. Which means I can focus "
        message += "all my attention on <em>you</em>.<br><br>"
        message += "Hmmm, let's see....what does a big <em><b>LOSER</b></em> like you deserve? Oh, a punishment of course. Instead of having you perform favors "
        message += "piecemeal, I'm going to lump them all together into one long, painful punishment session. "
        message += "Get ready to suffer, <em><b>LOSER</b></em>."
        show(message)
        showButton("Yikes!")
        punishment( PUNISHMENT_UNITS * NUM_FIGHT_LEVELS, FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(GLOBAL.fight_level)])
        show("Ha ha, hope you enjoyed that, <em><b>LOSER</b></em>. I sure did.")
        showButton("...")
        GLOBAL.favors_completed = GLOBAL.fight_level   // all favors were completed at once
        fa_save("favors_completed", GLOBAL.favors_completed)
    } else {              // if not the final fight level
        if (GLOBAL.favors_completed == 0) {
            message += "Ha ha! I am the winner and you are a LOSER.<br><br>"
            GLOBAL.favor_choices = STARTING_FAVOR_CHOICES.values() as String[]
            save_favor_choices()
        }
        def choice               // to choose which favor to demand
        if (GLOBAL.dope_inventory > 0) {                         // Demand to be given a dope capsule if the human has one
            choice = FAVOR_CHOICE.get_dope
        } else {
            if (GLOBAL.favor_choices.size() > 0) {               // Choose from among one of the informational choices if still available
                choice = GLOBAL.favor_choices[rand(0, GLOBAL.favor_choices.size() - 1)]
            } else {                                             // Otherwise demand the administering of dope
                choice = FAVOR_CHOICE.administer_dope
            }            
        }
        def opponent = get_fighters().computer
        message += "You have completed " + GLOBAL.favors_completed + " of the " + showS("favor", GLOBAL.fight_level) + " you owe me. "
        if (choice == FAVOR_CHOICE.get_dope) {
            message += "I want you to " + FAVOR_CHOICE.get_dope + "."
            show(message)
            showButton("Hand over a dope capsule")
            GLOBAL.dope_inventory--
            fa_save("dope_inventory", GLOBAL.dope_inventory)
        } else {
            message += opponent.name + " is my next opponent. I want you to " + choice + " " + opponent.name + "."
            show(message)
            showButton("Acknowledged")
            // Go to coach with the request and get punished
            setImage(FOLDER_NAME + GLOBAL.pics.coach)
            show("So you need to " + choice + " " + opponent.name + "? I will do that for you, but in exchange you are going to be punished.")
            showButton("Uh oh...")
            punishment(PUNISHMENT_UNITS, FOLDER_NAME + GLOBAL.pics.coach)            
            // show info or acknowledge doping at beginning of fight
            switch(choice) {
                case FAVOR_CHOICE.ssr:
                    opponent.unknown -= ["speed", "strength", "recupSkill"]
                    break
                case FAVOR_CHOICE.attSkills:
                    opponent.unknown -= ["attSkillArms", "attSkillLegs", "attSkillBody", "attSkillTarget"]
                    break
                case FAVOR_CHOICE.defSkills:
                    opponent.unknown -= ["defSkillArms", "defSkillLegs", "defSkillBody", "defSkillTarget"]
                    break
                case FAVOR_CHOICE.administer_dope:
                    opponent.dopeLevel += 1
            }
            if (choice == FAVOR_CHOICE.ssr || choice == FAVOR_CHOICE.attSkills || choice == FAVOR_CHOICE.defSkills) {
                show("Now that you've completed your part of the bargain, here's the info...")
                showButton("Let me see it")
            } else {
                show("I will administer the speed dope capsule shortly before the fight begins.")
                showButton("Acknowledged")
            }
            view_fighter_attributes()
            if (GLOBAL.favor_choices.size() > 0) {   // remove one of the favor choices
                GLOBAL.favor_choices -= choice
                save_favor_choices()                
            }
            show("Saving favor info...")
            save_fighter("fighter_left", GLOBAL.fighter_left)
            show("Saving favor info......")
            save_fighter("fighter_right", GLOBAL.fighter_right)            
        }
        
        // Let opponent acknowledge receipt of the information or dope capsule, and indicate favor was completed 
        setImage(FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(GLOBAL.fight_level)])
        show("Thank you.")
        showButton("You're welcome")
        GLOBAL.favors_completed++
        fa_save("favors_completed", GLOBAL.favors_completed)
     
    }

     // End off by changing tournament status and related settings, if all favors have been completed
    if (GLOBAL.favors_completed == GLOBAL.fight_level) {
        GLOBAL.favors_completed = 0
        fa_save("favors_completed", GLOBAL.favors_completed)
        GLOBAL.current_tournament_status = TOURNAMENT_STATUS.not_in
        fa_save("current_tournament_status", GLOBAL.current_tournament_status)
        GLOBAL.practice_sessions_completed = 0
        fa_save("practice_sessions_completed", GLOBAL.practice_sessions_completed)
        GLOBAL.fight_level = 0
        fa_save("fight_level", GLOBAL.fight_level)
        GLOBAL.fight_levels_completed = 0
        fa_save("fight_levels_completed", GLOBAL.fight_levels_completed)
        if (GLOBAL.fighter_left.isHuman) {
            changeFighterNum(GLOBAL.fighter_left, DEFAULT_PLAYER_NUM)
            changeFighterName(GLOBAL.fighter_left, loadString("intro.name"))
            GLOBAL.fighter_right = GLOBAL.coach
        } else {
            GLOBAL.fighter_left = GLOBAL.coach
            changeFighterNum(GLOBAL.fighter_right, DEFAULT_PLAYER_NUM)
            changeFighterName(GLOBAL.fighter_right, loadString("intro.name"))
        }
        save_fighter("fighter_left", GLOBAL.fighter_left)
        save_fighter("fighter_right", GLOBAL.fighter_right)
        show("You have completed all of your required favors.")
        showButton("Okay")
    }
}

// Get sexual favors for winning the tournament
def get_sexual_favors = {
    def message = ""
    message += "I have completed " + GLOBAL.favors_completed + " of the " + showS("favor", GLOBAL.fight_levels_completed) + " I owe you. "
    message += "What would you like me to do?"    
    def choice = getSelectedValue(message, ["Talk dirty for me", "Give me stroking instructions", "Cum or deny", "Punish me"])
    GLOBAL.favors_completed++
    fa_save("favors_completed", GLOBAL.favors_completed)
    switch(choice)  {
        case 0:
            def dirtyPhrases = [ "Oh yeah, fuck me good, fuck me hard. Just like that, ooh yeah, that's real good.",
                                 "I'm such a whore, sucking and fucking you. You make me so wet. I'm such a fucking slut.",
                                 "Stroke me. Caress me. Put your fingers in my holes. Lick me all over.",
                                 "I'm so horny, I want to cum so bad. Make me cum, please. Keep doing it, just like that, oh yeah. I'm going to cum...",
                                 "Look at me, look at how sexy I am. I'm a total slut. Here I am, for you, to do what you want to me.",
                                 "My nipples are so hard, I'm so wet, I want to fuck you so good. Let me touch you. Do you like that?",
                                 "See these tight jean-shorts around my tight ass? Shall I take them off slowly for you?",
                                 ]
            def dirtyChoice = rand(0, dirtyPhrases.size()-1)
            show(dirtyPhrases[dirtyChoice])
            showButton("Okay")
            break
        case 1:
            show("Get naked.")
            showButton("I'm naked")
            def n = rand(3, 7)
            for (def i=1; i <=n; i++) {
                def commands = ["Stroke yourself slowly.",
                                "Run a single finger over the sensitive areas of your genitalia.",
                                "Caress your nipples.",
                                "Tap yourself gently right in <em>that</em> spot.",
                                "Pleasure yourself using two fingers in a circular motion."]
                def option = rand(0, commands.size()-1)
                show(commands[option])
                waitWithGauge(rand(20,90)) 
                }
            break
        case 2:
            def result = rand(1, 5)
            if (result == 1) {
                show("You can cum.")
                showButton("I came")
            } else {
                show("You're denied.")
                showButton("Acknowledged")
            }
            break
        case 3:
            show("I warned you earlier, I wasn't going to allow you to change your mind. No punishment for you.")
            showButton("Acknowledged")
            break
    }
    message = "That completes the favor. "
    if (choice != 3) {
        message += "Told you I wasn't very good at giving sexual favors."
    }
    show(message)
    showButton("Urgh...")
}


// Let human player request a favor from the computer opponent who was beaten in a fight
def request_favor = {
    setImage(FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(GLOBAL.fight_levels_completed)])
    def message = ""
    def opponent = get_fighters().computer

    if (GLOBAL.fight_levels_completed == NUM_FIGHT_LEVELS) {   // if the final fight level has been completed
        if (GLOBAL.favors_completed == 0) {
            message += "Well, here we are, I can't believe it. It was down to just the two of us out of " + NUM_COMPETITORS + " competitors. "
            message += "And now you've won the final fight, making you the winner of the tournament. Unbelievable. I mean, you seem so pathetic.<br><br>"
            message += "But I guess now I owe you some favors, "
            message += NUM_FIGHT_LEVELS + " of them in fact. And because the tournament is now over, you don't need to worry "
            message += "about scheming against your next opponent&mdash;there are no more opponents to worry about. So you can have your way with me. Oh, yes, "
            message += "I almost forgot&mdash;you are also allowed now to start masturbating and even have an orgasm.<br><br>"
            show(message)
            showButton("Awesome!")
            message = "But is that what you <em>really</em> want? You just don't seem like the winning type. You winning this tournament "
            message += "was just a fluke. I think that secretly you were actually hoping to <em>lose</em> the final fight. "
            message += "Because isn't that what you really are, a <em><b>LOSER</b></em> who wants to be punished?<br><br>"
            message += "So I'm going to give you a choice. You can request " + NUM_FIGHT_LEVELS + " favors from me according to the tournament rules, "
            message += "or we can alter the rules a little bit and "
            message += "you can request punishment from me, which I'll give you in one long painful punishment session. Take your time and think over "
            message += "the two options carefully, as I won't allow you to change your mind. I must say, I'm not very good at giving sexual favors. "
            message += "But of course a <em><b>LOSER</b></em> like you already knows that, eh?<br><br>"
            message += "What would you like me to do?"
            def choice = getSelectedValue(message, ["Give me the " + NUM_FIGHT_LEVELS + " favors that I earned", "Punish me hard!"])
            if (choice == 1) {
                message = "Ha ha, you won the tournament and now you're about to be punished. You had a chance to have your way with me, but instead "
                message += "you proved just how pathetic you are.<br><br>"
                message += "Get ready to suffer, <em><b>LOSER</b></em>."
                show(message)
                showButton("I'm a pathetic loser")
                punishment( PUNISHMENT_UNITS * NUM_FIGHT_LEVELS, FOLDER_NAME + GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(GLOBAL.fight_levels_completed)])
                show("Ha ha, hope you enjoyed that, <em><b>LOSER</b></em>. I sure did.")
                showButton("...")
                GLOBAL.favors_completed = GLOBAL.fight_levels_completed   // all favors were completed at once
                fa_save("favors_completed", GLOBAL.favors_completed)
            } else {     // if the user chose not to be punished
                get_sexual_favors()
            }           
        } else {                       // if at least one favor as been completed
            get_sexual_favors()
        }
    } else {   // if not the final fight level completed
        // Construct list of favor choices
        if (GLOBAL.favors_completed == 0) {
            GLOBAL.dope_available = DOPE_CAPSULES_PER_LEVEL[GLOBAL.fight_levels_completed]
            fa_save("dope_available", GLOBAL.dope_available)
            GLOBAL.favor_choices = []
            for (choice in STARTING_FAVOR_CHOICES) {                                               
                GLOBAL.favor_choices += choice.value.capitalize() + " " + opponent.name           // informational choices
            }
        }
        def adminDopeChoice = FAVOR_CHOICE.administer_dope.capitalize() + " " + opponent.name
        def getDopeChoice = FAVOR_CHOICE.get_dope.capitalize()
        if (GLOBAL.dope_inventory > 0) {                                                         // choice to administer a dope capsule
            GLOBAL.favor_choices += adminDopeChoice
        }
        if (GLOBAL.dope_available > 0) {                                                         // choice to get a dope capsule
            GLOBAL.favor_choices += getDopeChoice
        }
        save_favor_choices()


        // Show the choices to the human player
        message += "As the defeated fighter, I have completed " + GLOBAL.favors_completed + " of the "
        message += showS("favor", GLOBAL.fight_levels_completed) + " I owe you.<br><br>"
        message += "Your Coach " + GLOBAL.coach.name + " tells me that " + opponent.name + " is your next opponent " + " and that you have "
        message += showS("dope capsule", GLOBAL.dope_inventory) + " in your possession. I myself have " + showS("dope capsule", GLOBAL.dope_available) + " "
        message += "that I could give you.<br><br>"
        message += "What would you like me to do?"    
        def playerChoice = getSelectedValue(message, GLOBAL.favor_choices)

        
        // Act on the player's choice
        switch(GLOBAL.favor_choices[playerChoice]) {
            case FAVOR_CHOICE.ssr.capitalize() + " " + opponent.name:
                opponent.unknown -= ["speed", "strength", "recupSkill"]
                show("Here's the info...")
                showButton("Let me see it")
                view_fighter_attributes()
                break
            case FAVOR_CHOICE.attSkills.capitalize() + " " + opponent.name:
                opponent.unknown -= ["attSkillArms", "attSkillLegs", "attSkillBody", "attSkillTarget"]
                show("Here's the info...")
                showButton("Let me see it")
                view_fighter_attributes()
                break
            case FAVOR_CHOICE.defSkills.capitalize() + " " + opponent.name:
                opponent.unknown -= ["defSkillArms", "defSkillLegs", "defSkillBody", "defSkillTarget"]
                show("Here's the info...")
                showButton("Let me see it")
                view_fighter_attributes()
                break
            case adminDopeChoice:
                GLOBAL.dope_inventory--
                opponent.dopeLevel++
                show("I will administer the dope to " + opponent.name + " shortly before the fight begins.")
                showButton("Thank you")
                view_fighter_attributes()
                break
            case getDopeChoice:
                GLOBAL.dope_inventory++
                GLOBAL.dope_available--
                show("Here you are.")
                showButton("Thank you")
                break
        }
        GLOBAL.favor_choices -= GLOBAL.favor_choices[playerChoice]     // Removes the choice made from further consideration
        if (adminDopeChoice in GLOBAL.favor_choices) {                 // Removed even if not chosen, because we reconsider adding each time favor is performed
            GLOBAL.favor_choices -= adminDopeChoice
        }
        if (getDopeChoice in GLOBAL.favor_choices) {                   // Removed even if not chosen, because we reconsider adding each time favor is performed
            GLOBAL.favor_choices -= getDopeChoice
        }
        show("Saving favor info...")
        save_favor_choices()
        fa_save("dope_inventory", GLOBAL.dope_inventory)
        fa_save("dope_available", GLOBAL.dope_available)
        GLOBAL.favors_completed++
        fa_save("favors_completed", GLOBAL.favors_completed)
        save_fighter("fighter_left", GLOBAL.fighter_left)
        show("Saving favor info......")
        save_fighter("fighter_right", GLOBAL.fighter_right)
        show("Saving favor info.........")
    }
    

    
     // End off by changing tournament status and related settings, if all favors have been completed
    if (GLOBAL.favors_completed == GLOBAL.fight_levels_completed) {
        if (GLOBAL.fight_levels_completed == NUM_FIGHT_LEVELS) {
            GLOBAL.current_tournament_status = TOURNAMENT_STATUS.not_in
            fa_save("current_tournament_status", GLOBAL.current_tournament_status)
            GLOBAL.practice_sessions_completed = 0
            fa_save("practice_sessions_completed", GLOBAL.practice_sessions_completed)
            GLOBAL.fight_level = 0
            fa_save("fight_level", GLOBAL.fight_level)
            GLOBAL.fight_levels_completed = 0
            fa_save("fight_levels_completed", GLOBAL.fight_levels_completed)
            if (GLOBAL.fighter_left.isHuman) {
                changeFighterNum(GLOBAL.fighter_left, DEFAULT_PLAYER_NUM)
                changeFighterName(GLOBAL.fighter_left, loadString("intro.name"))
                GLOBAL.fighter_right = GLOBAL.coach
            } else {
                GLOBAL.fighter_left = GLOBAL.coach
                changeFighterNum(GLOBAL.fighter_right, DEFAULT_PLAYER_NUM)
                changeFighterName(GLOBAL.fighter_right, loadString("intro.name"))
            }
            save_fighter("fighter_left", GLOBAL.fighter_left)
            save_fighter("fighter_right", GLOBAL.fighter_right)            
        } else {
            fight_now_or_later()
        }
        GLOBAL.favors_completed = 0
        fa_save("favors_completed", GLOBAL.favors_completed)         
        show("I have completed all of my required favors.")
        showButton("Okay")
    } 
}

// This is the main game play
def game_play = {

    def message_action = {
       def when_fight_starts
        if (GLOBAL.current_tournament_status == TOURNAMENT_STATUS.awaiting_fight_start ||  GLOBAL.current_tournament_status == TOURNAMENT_STATUS.fight_when_ready) {
            when_fight_starts = fight_start_time_string()
        }
        def styleString = " style=\"font-style:italic;color:#006600;\""
        def message = "<p style=\"padding-bottom:24pt\">I'm " + GLOBAL.coach.name + ", your coach and trainer for the Sexopolis Fight Arena. "
        message += "You have " + showS("dope capsule", GLOBAL.dope_inventory) + " in your possession.</p>"
        message += "<table>"
        message += "<tr><th colspan=\"2\">Tournament Stats, General</th></tr>"
        message += "<tr><td" + styleString + "># of tournaments won:</td><td>" + GLOBAL.tournaments_won + "</td></tr>"
        message += "<tr><td" + styleString + "># of tournaments lost:</td><td>" + GLOBAL.tournaments_lost + "</td></tr>"
        message += "</table><br>"
        message += "<table>"
        if (GLOBAL.current_tournament_status != TOURNAMENT_STATUS.not_in) {
            message += "<tr><th colspan=\"2\">Stats for Current Tournament (#" + GLOBAL.tournament_num + ")</th></tr>"
        }
        if (GLOBAL.current_tournament_status != TOURNAMENT_STATUS.not_in) {
            message += "<tr><td" + styleString + "># of fight levels completed:</td><td>" + GLOBAL.fight_levels_completed + " of " + NUM_FIGHT_LEVELS + "</td></tr>"
        }
        if (GLOBAL.current_tournament_status != TOURNAMENT_STATUS.not_in && GLOBAL.current_tournament_status != TOURNAMENT_STATUS.fight_lost_do_favors) {
            message += "<tr><td" + styleString + "># of competitors remaining:</td><td>" + GLOBAL.num_competitors_remaining + " (including you)</td></tr>"
        } 
        message += "<tr><td" + styleString + ">Current tournament status:</td><td>" + GLOBAL.current_tournament_status + "</td></tr>"
        message += "<tr><td" + styleString + ">Specifics for this status:</td><td>"
        switch (GLOBAL.current_tournament_status) {
            case TOURNAMENT_STATUS.not_in:
                message += "Enter tournament when you are ready"
                break
            case TOURNAMENT_STATUS.practicing:
                message += GLOBAL.practice_sessions_completed + " of " + PRACTICE_SESSIONS + "  practice sessions completed"
                break
            case TOURNAMENT_STATUS.awaiting_fight_start:
            case TOURNAMENT_STATUS.fight_when_ready:
                message += "Can start level " + GLOBAL.fight_level + " fight " + when_fight_starts + "<br>"
                message += GLOBAL.num_ties + " of at most " + TIE_REMATCH_LIMIT + " ties at this level"
                break
            case TOURNAMENT_STATUS.fight_started:
                message += "You left the level " + GLOBAL.fight_level + " fight part-way through and must forfeit"
                break
            case TOURNAMENT_STATUS.fight_lost_do_favors:
                message += GLOBAL.favors_completed + " of " + GLOBAL.fight_level + " favors completed"
                break
            case TOURNAMENT_STATUS.fight_won_get_favors:
                message += GLOBAL.favors_completed + " of " + GLOBAL.fight_levels_completed + " favors received"
                break
        }
        message += "</td></tr></table>"
        message += "<p style=\"padding-top:24pt\">What would you like to do?</p>"
        return message
    }
    def get_actions = {
        def statusActionMap =
            [ (TOURNAMENT_STATUS.not_in):               [label: "Enter Tournament",                   action: enter_tournament],
              (TOURNAMENT_STATUS.practicing):           [label: "Practice",                           action: practice_a_skill],
              (TOURNAMENT_STATUS.fight_when_ready):     [label: "Go to Fight Ring",                   action: fight_ring],
              (TOURNAMENT_STATUS.fight_started):        [label: "Forfeit",                            action: forfeit],
              (TOURNAMENT_STATUS.fight_lost_do_favors): [label: "Perform Favor",                      action: perform_favor],
              (TOURNAMENT_STATUS.fight_won_get_favors): [label: "Request Favor",                      action: request_favor]
            ]
        def actionList = [[label: "View General Info",                      action: tournament_info ],
                          [label: "View Bonus Info",                        action: bonus_info ],
                          [label: "View Fighter Attributes",                action: view_fighter_attributes ]]
        if (GLOBAL.current_tournament_status in statusActionMap) {
            actionList += statusActionMap[GLOBAL.current_tournament_status]            
        }
        actionList += [[label: "Done For Now",                              action: {}]]
        return actionList
    }


    menu( get_actions, { FOLDER_NAME + GLOBAL.pics.coach }, message_action)
    
}

// Displays the sound test screen and plays a test sound so the user can make sure their sound is working
def soundTest = {
    def clipLength = 13
    int elapsedTime = clipLength
    show("<h2>Sound Test</h2><p>This script includes sound. There is a background sound currently playing in a continuous loop. " +
                                 "Make sure you can hear it, and adjust your volume accordingly.<p>")
    while (elapsedTime == clipLength) {
        playBackgroundSound(FOLDER_NAME + "sound_test.mp3")
        elapsedTime = Math.round(showButton("Confirmed", clipLength))
    } 
   
}

// Sets the value of the indicated key in the data registry to default_value and returns default_value
def resetValue = {
    key, default_value ->
    fa_save(key, default_value)
    return default_value
}

// Sets the value of  indicated key in the data registry to default_fighter and returns default_fighter
def reset_fighter = {
    key, default_fighter -> 
    save_fighter(key, default_fighter)
    return default_fighter
}

// Clears the data registry for the game, and sets all GLOBAL variables to appropriate default values
def resetGameSettings = {
    def proceed_with_reset
    def message = ""
    message += "You are about to reset all game settings to their default values. This means that all of the following will be wiped out:"
    message += "<ul>"
    message += "<li>Your customized coach's name</li>"
    message += "<li>Your customized picture choices for your coach and fighters</li>"
    message += "<li>Your permitted punishment choices</li>"
    message += "<li>Your entire tournament, practice, and fight record</li>"
    message += "<li>Your fighter attributes</li>"
    message += "<li>The record of any dope in your possession</li>"
    message += "</ol><br><br>"
    message += "Are you sure you wish to reset all game settings?"
    proceed_with_reset = getBoolean(message, "Yes, reset all game settings", "No, cancel")
    if (proceed_with_reset) {
        show("Resetting game settings...")
        GLOBAL.pics.coach =                    resetValue("pics.coach", DEFAULT_PIC_COACH)
        for (level in 1..NUM_FIGHT_LEVELS) {
            GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)] =
                resetValue("pics." + FIGHTER_LEVEL_KEYSTRING + levelString(level), "default_" + FIGHTER_LEVEL_KEYSTRING + levelString(level) + ".png")
        }
        for (punishment_type in GLOBAL.punishments_permitted) {
            punishment_type.value.permitted = resetValue("punishment_type." + punishment_type.key, DEFAULT_PUNISHMENT_VALUE)
        }
        GLOBAL.tournament_num =                resetValue("tournament_num", 0)
        GLOBAL.fighter_left =                  reset_fighter("fighter_left", createLevel1Fighter(DEFAULT_PLAYER_NUM, FIGHTER_TYPE.human, loadString("intro.name")))
        show("Resetting game settings......")
        GLOBAL.fighter_right =                 reset_fighter("fighter_right", createLevel1Fighter(COACH_NUM, FIGHTER_TYPE.coach, DEFAULT_COACH_NAME))
        show("Resetting game settings.........")
        GLOBAL.coach =                         reset_fighter("coach", GLOBAL.fighter_right)
        GLOBAL.fight_level =                   resetValue("fight_level", 0)
        GLOBAL.fight_levels_completed =        resetValue("fight_levels_completed", 0)
        GLOBAL.num_competitors_remaining =     resetValue("num_competitors_remaining", NUM_COMPETITORS)
        GLOBAL.practice_sessions_completed =   resetValue("practice_sessions_completed", 0)
        GLOBAL.countdown_start_time =          resetValue("countdown_start_time", 0)
        GLOBAL.current_tournament_status =     resetValue("current_tournament_status", TOURNAMENT_STATUS.not_in)
        GLOBAL.num_ties =                      resetValue("num_ties", 0)
        GLOBAL.tournaments_won =               resetValue("tournaments_won", 0)
        GLOBAL.tournaments_lost =              resetValue("tournaments_lost", 0)
        GLOBAL.favors_completed =              resetValue("favors_completed", 0)
        def favor_choices_count =              resetValue("favor_choices_count", 0)
        GLOBAL.favor_choices =                 []
        GLOBAL.dope_inventory =                resetValue("dope_inventory", 0)
        GLOBAL.dope_available =                resetValue("dope_available", 0)
        show("All game settings have been reset.")
        showButton("Acknowledged")
    } else {
        show("No game settings have been changed.")
        showButton("Acknowledged")
    }
}

// Returns the value of a key from the registry, or default_value if the key is not in the registry (and sets the key to default_value)
def loadDefaultString = {
    key, default_value ->
    def result = loadString(SAVE_STRING + key)
    if (result == null) {
        fa_save(key, default_value)
        result = default_value
    }
    return result
}

// Returns the value of a key from the registry, or default_value if the key is not in the registry (and sets the key to default_value)
def loadDefaultBoolean = {
    key, default_value ->
    def result = loadBoolean(SAVE_STRING + key)
    if (result == null) {
        fa_save(key, default_value)
        result = default_value
    }
    return result
}

// Returns the value of a key from the registry, or default_value if the key is not in the registry (and sets the key to default_value)
def loadDefaultInteger = {
    key, default_value ->
    def result = loadInteger(SAVE_STRING + key)
    if (result == null) {
        fa_save(key, default_value)
        result = default_value
    }
    return result
}

// Returns the value of fighter indicated by key from the registry, or default_fighter if the key is not in the registry (and sets the key to default_fighter)
def load_fighter = {
    key, default_fighter -> 
    if (loadInteger(SAVE_STRING + key + ".num") == null) {
        save_fighter(key, default_fighter)
    } else {
        default_fighter["num"] = loadInteger(SAVE_STRING + key + ".num")
        default_fighter["name"] = loadString(SAVE_STRING + key + ".name")
        default_fighter["isHuman"] = loadBoolean(SAVE_STRING + key + ".isHuman")
        default_fighter["you"] = loadString(SAVE_STRING + key + ".you")
        default_fighter["you_lc"] = loadString(SAVE_STRING + key + ".you_lc")
        default_fighter["s"] = loadString(SAVE_STRING + key + ".s")
        default_fighter["es"] = loadString(SAVE_STRING + key + ".es")
        default_fighter["have"] = loadString(SAVE_STRING + key + ".have")
        default_fighter["dopeLevel"] = loadInteger(SAVE_STRING + key + ".dopeLevel")
        default_fighter["speed"] = loadInteger(SAVE_STRING + key + ".speed")
        default_fighter["strength"] = loadInteger(SAVE_STRING + key + ".strength")
        default_fighter["recupSkill"] = loadInteger(SAVE_STRING + key + ".recupSkill")
        default_fighter["attSkillArms"] = loadInteger(SAVE_STRING + key + ".attSkillArms")
        default_fighter["attSkillLegs"] = loadInteger(SAVE_STRING + key + ".attSkillLegs")
        default_fighter["attSkillBody"] = loadInteger(SAVE_STRING + key + ".attSkillBody")
        default_fighter["attSkillTarget"] = loadInteger(SAVE_STRING + key + ".attSkillTarget")
        default_fighter["defSkillArms"] = loadInteger(SAVE_STRING + key + ".defSkillArms")
        default_fighter["defSkillLegs"] = loadInteger(SAVE_STRING + key + ".defSkillLegs")
        default_fighter["defSkillBody"] = loadInteger(SAVE_STRING + key + ".defSkillBody")
        default_fighter["defSkillTarget"] = loadInteger(SAVE_STRING + key + ".defSkillTarget")
        default_fighter["health"] = MAX_HEALTH
        default_fighter["priority"] = BASE_PRIORITY + default_fighter.speed
        default_fighter["points"] = 0
        def unknown_count = loadInteger(SAVE_STRING + key + ".unknown_count")
        default_fighter["unknown"] = []
        for (def index = 0; index < unknown_count; index++) {
            default_fighter["unknown"] += loadString(SAVE_STRING + key + ".unknown" + index)
        }        
    }
    return default_fighter
}

// Loads all GLOBAL variables from the registry, substituting appropriate default values for any unregistered keys (and sets each key to its default value)
// (GLOBAL.current_fight_length is excluded, since its value does not need to be saved)
def load_saved_globals = {
    show("Loading Sexopolis Fight Arena...")
    GLOBAL.pics.coach = loadDefaultString("pics.coach", DEFAULT_PIC_COACH)
    for (level in 1..NUM_FIGHT_LEVELS) {
        GLOBAL.pics[FIGHTER_LEVEL_KEYSTRING + levelString(level)] = 
            loadDefaultString("pics." + FIGHTER_LEVEL_KEYSTRING + levelString(level), "default_" + FIGHTER_LEVEL_KEYSTRING + levelString(level) + ".png")
    }
    for (punishment_type in GLOBAL.punishments_permitted) {
        punishment_type.value.permitted = loadDefaultBoolean("punishment_type." + punishment_type.key, DEFAULT_PUNISHMENT_VALUE)
    }
    GLOBAL.tournament_num = loadDefaultInteger("tournament_num", 0)
    GLOBAL.fighter_left = load_fighter("fighter_left", createLevel1Fighter(DEFAULT_PLAYER_NUM, FIGHTER_TYPE.human, loadString("intro.name")))
    show("Loading Sexopolis Fight Arena......")
    GLOBAL.fighter_right = load_fighter("fighter_right", createLevel1Fighter(COACH_NUM, FIGHTER_TYPE.coach, DEFAULT_COACH_NAME))
    if (GLOBAL.fighter_left.num == COACH_NUM) {       // if the fighter on the left is the coach 
        GLOBAL.coach = GLOBAL.fighter_left            //    point the coach to the fighter_left data space
    } else {
        if (GLOBAL.fighter_right.num == COACH_NUM) {  // if the fighter on the right is the coach
            GLOBAL.coach = GLOBAL.fighter_right       //    point the coach to the fighter_right data space
        } else {                                      // if the coach is neither the left nor right fighter, create new data space for the coach
            GLOBAL.coach = load_fighter("coach", createLevel1Fighter(COACH_NUM, FIGHTER_TYPE.coach, DEFAULT_COACH_NAME))
        }
    }
    GLOBAL.fight_level = loadDefaultInteger("fight_level", 0)
    GLOBAL.fight_levels_completed = loadDefaultInteger("fight_levels_completed", 0)
    GLOBAL.num_competitors_remaining = loadDefaultInteger("num_competitors_remaining", NUM_COMPETITORS)
    GLOBAL.practice_sessions_completed = loadDefaultInteger("practice_sessions_completed", 0)
    GLOBAL.countdown_start_time = loadDefaultInteger("countdown_start_time", 0)
    GLOBAL.current_tournament_status = loadDefaultString("current_tournament_status", TOURNAMENT_STATUS.not_in)
    GLOBAL.num_ties = loadDefaultInteger("num_ties", 0)
    GLOBAL.tournaments_won = loadDefaultInteger("tournaments_won", 0)
    GLOBAL.tournaments_lost = loadDefaultInteger("tournaments_lost", 0)
    GLOBAL.favors_completed = loadDefaultInteger("favors_completed", 0)
    def favor_choices_count = loadDefaultInteger("favor_choices_count", 0)
    GLOBAL.favor_choices = []
    for (def index = 0; index < favor_choices_count; index++) {
        GLOBAL.favor_choices += loadString(SAVE_STRING + "favor_choice" + index)
    }
    GLOBAL.dope_inventory = loadDefaultInteger("dope_inventory", 0)
    GLOBAL.dope_available = loadDefaultInteger("dope_available", 0)
}


// ######################################################## START OF MAIN SCRIPT  ########################################################                              

if (loadString("intro.name") == null) {    // Make sure the user has a name
    save("intro.name", "You")
}
load_saved_globals()                       // Load all global variables from the data registry, or initialize them to default values and save them to the registry

// Show options to the user and let them choose one in a loop until they decide to quit
def actionList = {[[label: "Sound Test",                           action: soundTest],
                  [label: "Change Coach Name",                     action: changeCoachName],
                  [label: "Change coach and fighter pictures",     action: changePictures],
                  [label: "Change Permitted Punishments",          action: changePunishmentsPermitted],
                  [label: "Reset Game Settings",                   action: resetGameSettings],
                  [label: "Proceed to Game",                       action: game_play],
                  [label: "Quit For Now",                          action: {} ]]}
def message_action = { "<h1 style=\"text-align:center\">WELCOME TO<br>" +
              "SEXOPOLIS FIGHT ARENA</h1>" +
              "<p style=\"text-align:center\">This script relies heavily on timing. Normal speed is recommended, but try Slow if the fighting goes too quickly. " +
              "(Use the SexScripts Options menu to change the speed.)</p><br>" +
              "<p style=\"text-align:center\">As the game play extends over ten or likely more days, the script saves your current status each time you play. " +
              "Choosing the Reset option will reset all game settings to their initial values, wiping out your fight record and experience as well " +
              "as your coach name and coach and fighter pictures. Use with caution!</p><br>" +
              "<p style=\"text-align:center\">Current coach name is " + GLOBAL.coach.name + ".</p><br>" +
              "<p style=\"text-align:center\">What would you like to do?</p>" }
                  
menu(actionList, { return FOLDER_NAME + "title_screen.png" }, message_action)





/*
 * Resources
 * scripts/fight_arena.groovy
 * images/fight_arena/chart_experience.png
 * images/fight_arena/chart_practice.png
 * images/fight_arena/chart_speed_and_doping.png
 * images/fight_arena/default_coach.png
 * images/fight_arena/default_fighter_level01.png
 * images/fight_arena/default_fighter_level02.png
 * images/fight_arena/default_fighter_level03.png
 * images/fight_arena/default_fighter_level04.png
 * images/fight_arena/default_fighter_level05.png
 * images/fight_arena/default_fighter_level06.png
 * images/fight_arena/default_fighter_level07.png
 * images/fight_arena/default_fighter_level08.png
 * images/fight_arena/default_fighter_level09.png
 * images/fight_arena/default_fighter_level10.png
 * images/fight_arena/fight_ring.png
 * images/fight_arena/title_screen.png
 * sounds/fight_arena/bodyslam1shoulder.mp3
 * sounds/fight_arena/bodyslam2yelp_high.mp3
 * sounds/fight_arena/bodyslam3moan_high.mp3
 * sounds/fight_arena/end_fight_ding.mp3
 * sounds/fight_arena/fight_results.mp3
 * sounds/fight_arena/flick1.mp3
 * sounds/fight_arena/flick3.mp3
 * sounds/fight_arena/introduce_fighters.mp3
 * sounds/fight_arena/kick1kick.mp3
 * sounds/fight_arena/kick2cry_high.mp3
 * sounds/fight_arena/kick3groan_high.mp3
 * sounds/fight_arena/point_scored.mp3
 * sounds/fight_arena/punch1punch.mp3
 * sounds/fight_arena/punch2grunt_high.mp3
 * sounds/fight_arena/punch3_high.mp3
 * sounds/fight_arena/sound_test.mp3
 * sounds/fight_arena/spank1.mp3
 * sounds/fight_arena/spank5.mp3
 * sounds/fight_arena/start_fight_ding.mp3
 * sounds/fight_arena/target_pressed_no_point.mp3
 * sounds/fight_arena/won_tournament.mp3  
 */